import java.util.*;

public class BoardPosition
{
    int AT[][];
    int MOVE_NUMBER, EnPassant, ReversibleCount;
    int COUNT_OF_LEGAL_MOVES;
    boolean WTM;
    int move_list[];
    String move_list_annotated[];
    RobboFrame CF;
    BoardPanel PANEL = null;

    public BoardPosition (BoardPosition BP) // copy
    {
	AT = new int[10][10];
	for (int i = 1; i <= 8; i++)
	    for (int j = 1; j <= 8; j++)
		AT[i][j] = BP.AT[i][j];
	MOVE_NUMBER = BP.MOVE_NUMBER;
	EnPassant = BP.EnPassant;
	ReversibleCount = BP.ReversibleCount;
	COUNT_OF_LEGAL_MOVES = BP.COUNT_OF_LEGAL_MOVES;
	WTM = BP.WTM;
	move_list = new int[256];
	move_list_annotated = new String[256];
	for (int i = 0; i < 256; i++)
	    {
		move_list[i] = BP.move_list[i];
		move_list_annotated[i] = new String (BP.move_list_annotated[i]);
	    }		    
	CF = BP.CF;
    }

    public BoardPosition (RobboFrame cf)
    {
	super ();
	CF = cf;
	AT = new int[10][10];
	for (int i = 0; i < 10; i++)
	    for (int j = 0; j < 10; j++)
		AT[i][j] = 0;
        AT = new int[10][10];
        for (int i = 0; i < 10; i++)
            for (int j = 0; j < 10; j++)
                AT[i][j] = 0;
        for (int i = 1; i <= 6; i++)
            AT[i + 1][0] = i;
        for (int i = 1; i <= 6; i++)
            AT[i + 1][9] = -i;

	WTM = true;
	MOVE_NUMBER = 1;
	EnPassant = 0;
	ReversibleCount = 0;
	move_list = new int[256];
	move_list_annotated = new String[256];
	for (int i = 0; i < 256; i++)
	    {
		move_list[i] = 0;
		move_list_annotated[i] = new String ("");
	    }
	MakeNormal ();
    }

    public void ClearBoard ()
    {
	for (int i = 1; i <= 8; i++)
	    for (int j = 1; j <= 8; j++)
		AT[i][j] = 0;
	EnPassant = 0;
	WTM = true;
	ReversibleCount = 0;
	MOVE_NUMBER = 1;
    }

    public void NewGame ()
    {
	for (int i = 1; i <= 8; i++)
	    for (int j = 1; j <= 8; j++)
		AT[i][j] = 0;
        AT[1][1] = 4;
        AT[2][1] = 2;
        AT[3][1] = 3;
	AT[4][1] = 5;
        AT[5][1] = 6;
        AT[6][1] = 3;
        AT[7][1] = 2;
        AT[8][1] = 4;
	for (int i = 1; i <= 8; i++)
            AT[i][8] = -AT[i][1];
        for (int i = 1; i <= 8; i++)
            AT[i][2] = 1;
        for (int i = 1; i <= 8; i++)
            AT[i][7] = -1;

        WTM = true;
	MOVE_NUMBER = 1;
        EnPassant = 0;
        ReversibleCount = 0;
    }

    public void SetString(StringTokenizer A)
    {ClearBoard();
     if (!A.hasMoreTokens()) {CF.TellInfo("Nothing in SET string?"); return;}
     while (A.hasMoreTokens())
     {String S=A.nextToken();
      if (S.equals("X")) {WTM=true; continue;}
      if (S.equals("O")) {WTM=false; continue;}
      if (S.equals("ep"))
      {if (!A.hasMoreTokens()) {CF.TellInfo("Bad ep string?"); return;}
       S=A.nextToken(); if (S.length()!=2) {CF.TellInfo("Bad ep?"); return;}
       char c0=S.charAt(0),c1=S.charAt(1);
       if (c0<'a'||c0>'h'||c1<'1'||c1>'8') {CF.TellInfo("Bad ep sq?"); return;}
       EnPassant=(c0-'a'+1); continue;}
      if (S.length()!=4) {CF.TellInfo("Bad token length?"); return;}
      char c=S.charAt(0),p=S.charAt(1),f=S.charAt(2),r=S.charAt(3);
      if (c!='w' && c!='b') {CF.TellInfo("Bad token color?"); return;}
      if (p!='P' && p!='N' && p!='B' && p!='Q' && p!='R' && p!='K')
      {CF.TellInfo("Bad token piece?"); return;}
      if (f<'a'||f>'h'||r<'1'||r>'h') {CF.TellInfo("Bad token sq?"); return;}
      int file=(f-'a'); int rank=(r-'1'); int piece=0;
      switch (p) {case 'P':piece=1; break; case 'N':piece=2; break;
                  case 'B':piece=3; break; case 'R':piece=4; break;
                  case 'Q':piece=5; break; case 'K':piece=6;}
      if (c=='b') piece=-piece; AT[file+1][rank+1]=piece; }}

    public void SetFEN (StringTokenizer ST)
    {
	String S, n;
	S = ST.nextToken ();
	StringBuffer SB = new StringBuffer (S);
	int rank = 8;
	int file = 1;
	for (int i = 1; i <= 8; i++)
	    for (int j = 1; j <= 8; j++)
		AT[i][j] = 0;
	for (int w = 0; w < S.length(); w++)
	    {
		char c = SB.charAt (w);
		if (rank < 1)
		    {
			CF.TellInfo ("Bad FEN? Too many ranks");
			return;
		    }
		if (c == '/')
		    {
			rank--;
			file = 1;
		    }
		else if (file > 8)
		    {
			CF.TellInfo ("Bad FEN? Too many files in rank " + rank);
			return;
		    }
		if (c == '1')
		    file++;
		if (c == '2')
		    file += 2;
		if (c == '3')
		    file += 3;
		if (c == '4')
		    file += 4;
		if (c == '5')
		    file += 5;
		if (c == '6')
		    file += 6;
		if (c == '7')
		    file += 7;
		if (c == '8')
		    file += 8;
		if (c == 'K')
		    AT[file++][rank] = 6;
		if (c == 'Q')
		    AT[file++][rank] = 5;
		if (c == 'R')
		    AT[file++][rank] = 4;
		if (c == 'B')
		    AT[file++][rank] = 3;
		if (c == 'N')
		    AT[file++][rank] = 2;
		if (c == 'P')
		    AT[file++][rank] = 1;
		if (c == 'k')
		    AT[file++][rank] = -6;
		if (c == 'q')
		    AT[file++][rank] = -5;
		if (c == 'r')
		    AT[file++][rank] = -4;
		if (c == 'b')
		    AT[file++][rank] = -3;
		if (c == 'n')
		    AT[file++][rank] = -2;
		if (c == 'p')
		    AT[file++][rank] = -1;
		if ((new String ("/12345678KQRBNPkqrnbp").indexOf (c)) == -1)
		    {
			CF.TellInfo ("Bad FEN? character " + c + " at rank " + rank + " and file " + file);
			return;
		    }
	    }
	WTM = true;
	EnPassant = 0;
	MOVE_NUMBER = 1;
	if (ST.hasMoreTokens ())
	    {
		n = ST.nextToken ();
		if (n.equals ("b"))
		    WTM = false;
	    }
	if (ST.hasMoreTokens ())
	    n = ST.nextToken();
	if (ST.hasMoreTokens ())
	    {
		n = ST.nextToken();
		SB = new StringBuffer (n);
		if (n.equals ("-"))
		    EnPassant = 0;
		else
		    EnPassant = ((int) (SB.charAt (0) - 'a')) + 1;
	    }
	if (ST.hasMoreTokens ())
	    {
		n = ST.nextToken ();
		ReversibleCount = Integer.valueOf (n).intValue ();
	    }
	if (ST.hasMoreTokens ())
	    {
		n = ST.nextToken ();
		MOVE_NUMBER = Integer.valueOf (n).intValue ();
	    }
	MakeNormal ();
    }

    public String GetPieceString()
    {
	String S=new String("");
	String C=new String("0PNBRQK");
	if (!WTM) S="O"; else S="X";
	int r=1,f=1;
	for (r=1;r<=8;r++) for (f=1;f<=8;f++) if (AT[f][r]!=0)
	{int w=AT[f][r];
	 if (w<0) S+=" b"+C.charAt(-w); else S+=" w"+C.charAt(w);
	 S+=((char) ('a'+(char) (f-1))); S+=((char) ('0'+(char) (r)));}
	if (EnPassant !=0 && EnPassant < 10)
	    {
		S+=" ep ";
		if (!WTM)
		    S += (char) (((char) EnPassant) + 'a' - (char) 1) + "" + 3;
		else
		    S += (char) (((char) EnPassant) + 'a' - (char) 1) + "" + 6;
		
	    }

	return S;
    }

    public String GetPositionalFEN ()
    {
	String R = new String ("");
	int rank = 8, file = 1, c = 0;
	while (true)
	    {
		while (AT[file][rank] == 0)
		    {
			file++;
			c++;
			if (file == 9)
			    {
				R += "" + c + "";
				if (rank != 1)
				    R += "/";
				else
				    return R;
				rank--;
				file = 1;
				c = 0;
			    }
		    }
		if (c != 0)
		    R = R + c;
		switch (AT[file][rank])
		    {
		    case 1: R = R + "P"; break;
		    case 2: R = R + "N"; break;
		    case 3: R = R + "B"; break;
		    case 4: R = R + "R"; break;
		    case 5: R = R + "Q"; break;
		    case 6: R = R + "K"; break;
		    case -1: R = R + "p"; break;
		    case -2: R = R + "n"; break;
		    case -3: R = R + "b"; break;
		    case -4: R = R + "r"; break;
		    case -5: R = R + "q"; break;
		    case -6: R = R + "k"; break;
		    }
		file++;
		c = 0;
		if (file == 9)
		    {
			if (rank != 1)
			    R += "/";
			else
			    return R;
			rank--;
			file = 1;
			c = 0;
		    }
	    }
    }

    public String GetFEN ()
    {
	String R = GetPositionalFEN ();
	if (WTM)
	    R += " w ";
	else
	    R += " b ";
	R += "-";
	R += " ";
	if (EnPassant == 0)
	    R += "-";
	else
	    {
		if (!WTM)
		    R += (char) (((char) EnPassant) + 'a' - (char) 1) + "" + 3;
		else
		    R += (char) (((char) EnPassant) + 'a' - (char) 1) + "" + 6;
	    }
	//	R += " " + ReversibleCount + " " + MOVE_NUMBER;
	return R;
    }

    public int FindMove (String S)
    {
	StringBuffer SB = new StringBuffer (S);
	int u = 0;
	while (!IsLetter (SB.charAt (u)))
	    u++;
	int from_file = SB.charAt (u) - 'a';
	u++;
	while (!IsDigit (SB.charAt (u)))
	    u++;
	int from_rank = SB.charAt (u) - '1';
	u++;
	while (!IsLetter (SB.charAt (u)))
	    u++;
	int to_file = SB.charAt (u) - 'a';
	u++;
	while (!IsDigit (SB.charAt (u)))
	    u++;
	int to_rank = SB.charAt (u) - '1';
	u++;
	boolean prom = false;
	char pr = 'a';
	int v = from_file + (from_rank << 3) + (to_file << 6) + (to_rank << 9);
	if (S.length () > u)
	    {
		prom = true;
		while (SB.charAt (u) == '=') u++;
		pr = SB.charAt (u);
		if (pr < 'a')
		    pr += 'a' - 'A';
	    }
	for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
	    {
		if (v == (move_list[i] & 0xfff))
		    {
			if (!prom)
			    return i;
			int w = (move_list[i] >> 17) & 7;
			if (pr == 'k' && w == 6)
			    return i;
			if (pr == 'q' && w == 5)
			    return i;
			if (pr == 'r' && w == 4)
			    return i;
			if (pr == 'b' && w == 3)
			    return i;
			if (pr == 'n' && w == 2)
			    return i;
		    }
	    }
	return -1;
    }

    public void AddThisMove (int v)
    {
        move_list[COUNT_OF_LEGAL_MOVES++] = v;
    }

    public boolean IsLetter (char x)
    {
        return ((x >= 'a') && (x <= 'h'));
    }
    
    public boolean IsDigit (char x)
    {
        return ((x >= '1') && (x <= '8'));
    }

    public void AddMove
        (int from_file, int from_rank, int to_file, int to_rank, int type)
    {
        int v = (from_file - 1) + ((from_rank - 1) << 3) +
            ((to_file - 1) << 6) + ((to_rank - 1) << 9) + (type << 12);
        if (WTM && AT[from_file][from_rank] == 1 && from_rank == 7)
            {
                for (int i = 6; i >= 2; i--)
		    AddThisMove (v + (i << 17));
                return;
            }
        if (!WTM && AT[from_file][from_rank] == -1 && from_rank == 2)
            {
                for (int i = 6; i >= 2; i--)
		    AddThisMove (v + (i << 17));
                return;
            }
        AddThisMove (v);
    }

    public void LegalWhite
        (int from_file, int from_rank, int to_file, int to_rank, int type)
    {AddMove (from_file, from_rank, to_file, to_rank, type);}

    public void LegalBlack
        (int from_file, int from_rank, int to_file, int to_rank, int type)
    {AddMove (from_file, from_rank, to_file, to_rank, type);}

    public boolean CheckMove
	(int from_file, int from_rank, int to_file, int to_rank)
    {
	if (WTM)
	    {
		if (AT[to_file][to_rank] == 0)
		    {
			LegalWhite (from_file, from_rank, to_file, to_rank, 0);
			return false;
		    }
		if (AT[to_file][to_rank] < 0)
		    LegalWhite (from_file, from_rank, to_file, to_rank, -AT[to_file][to_rank]);
		return true;
	    }
	else
	    {
		if (AT[to_file][to_rank] == 0)
		    {
			LegalBlack (from_file, from_rank, to_file, to_rank, 0);
			return false;
		    }
		if (AT[to_file][to_rank] > 0)
		    LegalBlack (from_file, from_rank, to_file, to_rank, AT[to_file][to_rank]);
		return true;
	    }
    }

    public void GenerateMoves (int file, int rank)
    {
	int i, j, piece = AT[file][rank];
	if (!WTM)
	    piece = -piece;
	if (piece == 6 || piece == 5 || piece == 4)
	    {
		i = 1;
		while (file + i <= 8)
		    {
			if (CheckMove (file, rank, file + i, rank) || piece == 6)
			    break;
			i++;
		    }
		i = 1;
		while (file - i >= 1)
		    {
			if (CheckMove (file, rank, file - i, rank) || piece == 6)
			    break;
			i++;
		    }
		j = 1;
		while (rank + j <= 8)
		    {
			if (CheckMove (file, rank, file, rank + j) || piece == 6)
			    break;
			j++;
		    }
		j = 1;
		while (rank - j >= 1)
		    {
			if (CheckMove (file, rank, file, rank - j) || piece == 6)
			    break;
			j++;
		    }
	    }
	if (piece == 6 || piece == 5 ||  piece == 3)
	    {
		i = 1;
		while (file + i <= 8 && rank + i <= 8)
		    {
			if (CheckMove (file, rank, file + i, rank + i) || piece == 6)
			    break;
			i++;
		    }
		i = 1;
		while (file - i >= 1 && rank - i >= 1)
		    {
			if (CheckMove (file ,rank, file - i, rank - i) || piece == 6)
			    break;
			i++;
		    }
		i = 1;
		while (file + i <= 8 && rank - i >= 1)
		    {
			if (CheckMove (file, rank, file + i, rank - i) || piece == 6)
			    break;
			i++;
		    }
		i = 1;
		while (file - i >= 1 && rank + i <= 8)
		    {
			if (CheckMove (file, rank, file - i, rank + i) || piece == 6)
			    break;
			i++;
		    }
	    }
	if (piece == 2)
	    {
		if (file + 2 <= 8 && rank + 1 <= 8)
		    CheckMove (file, rank, file + 2, rank + 1);
		if (file + 1 <= 8 && rank + 2 <= 8)
		    CheckMove (file, rank, file + 1, rank + 2);
		if (file - 2 >= 1 && rank + 1 <= 8)
		    CheckMove (file, rank, file - 2, rank + 1);
		if (file - 1 >= 1 && rank + 2 <= 8)
		    CheckMove (file, rank, file - 1, rank + 2);
		if (file - 2 >= 1 && rank - 1 >= 1)
		    CheckMove (file, rank, file - 2, rank - 1);
		if (file - 1 >= 1 && rank - 2 >= 1)
		    CheckMove (file, rank, file - 1, rank - 2);
		if (file + 2 <= 8 && rank - 1 >= 1)
		    CheckMove (file, rank, file + 2, rank - 1);
		if (file + 1 <= 8 && rank - 2 >= 1)
		    CheckMove (file, rank, file + 1, rank - 2);
	    }
	if (piece == 1)
	    {
		if (WTM)
		    {
			if (file < 8 && AT[file + 1][rank + 1] < 0)
			    LegalWhite (file, rank, file + 1, rank + 1, -AT[file + 1][rank + 1]);
			if (file > 1 && AT[file - 1][rank + 1] < 0)
			    LegalWhite (file, rank, file - 1, rank + 1, -AT[file - 1][rank + 1]);
			if (AT[file][rank + 1] == 0)
			    LegalWhite (file, rank, file, rank + 1, 0);
			if (rank == 2 && AT[file][3] == 0 && AT[file][4] == 0)
			    LegalWhite (file, 2, file, 4, 0);
		    }
		else
		    {
			if (file < 8 && AT[file + 1][rank - 1] > 0)
			    LegalBlack (file, rank, file + 1,rank - 1, AT[file + 1][rank - 1]);
			if (file > 1 && AT[file - 1][rank - 1] > 0)
			    LegalBlack (file, rank, file - 1,rank - 1, AT[file - 1][rank - 1]);
			if (AT[file][rank - 1] == 0)
			    LegalBlack (file, rank, file, rank - 1, 0);
			if (rank == 7 && AT[file][6] == 0 && AT[file][5] == 0)
			    LegalBlack (file, 7, file, 5, 0);
		    }
	    }
    }

    public void GenerateAllMoves ()
    {
	int rank, file;
	if (EnPassant != 0)
	    {
		if (WTM)
		    {
			if (EnPassant < 8 && AT[EnPassant + 1][5] == 1)
			    LegalWhite (EnPassant + 1, 5, EnPassant, 6, 8);
			if (EnPassant > 1 && AT[EnPassant - 1][5] == 1)
			    LegalWhite (EnPassant - 1, 5, EnPassant, 6, 8);
		    }
		else
		    {
			if (EnPassant < 8 && AT[EnPassant + 1][4] == -1)
			    LegalBlack (EnPassant + 1, 4, EnPassant, 3, 8);
			if (EnPassant > 1 && AT[EnPassant - 1][4] == -1)
			    LegalBlack (EnPassant - 1, 4, EnPassant, 3, 8);
		    }
	    }
	if (WTM)
	    {
		for (rank = 1; rank <= 8; rank++)
		    for (file = 1; file <= 8; file++)
			if (AT[file][rank] > 0)
			    GenerateMoves (file, rank);
	    }
	else
	    {
		for (rank = 1; rank <= 8; rank++)
		    for (file = 1; file <= 8; file++)
			if (AT[file][rank] < 0)
			    GenerateMoves (file, rank);
	    }
	boolean cap = false;
	for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
	    if (((move_list[i] >> 12) & 0xf) != 0)
		cap = true;
	if (cap)
	    {
		int j=0;
		for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
		    if (((move_list[i] >> 12) & 0xf) != 0)
			move_list[j++] = move_list[i];
		COUNT_OF_LEGAL_MOVES = j;
		move_list[j] = 0;
	    }
	MakeNotation();
    }

    public void MakeNormal ()
    {
	for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
	    {
		move_list[i] = 0;
		move_list_annotated[i] = new String ("");
	    }
	if (EnPassant != 0)
	    {
		if (WTM && AT[EnPassant][5] != -1)
		    EnPassant = 0;
		else if (!WTM && AT[EnPassant][4] != 1)
		    EnPassant = 0;
	    }
	if (EnPassant != 0)
	    {
		if (WTM && AT[EnPassant + 1][5] != 1 && AT[EnPassant - 1][5] !=
 1)
		    EnPassant = 0;
		else if (!WTM && AT[EnPassant + 1][4] != -1 && AT[EnPassant - 1][4] != -1)
		    EnPassant = 0;
	    }
	COUNT_OF_LEGAL_MOVES = 0;
	GenerateAllMoves ();
    }

    public void MakeNotation ()
    { 
	int move, check, prom, type, piece;
	boolean cap;
	String S;
	for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
	    {
		move = move_list[i];
		type = (move >> 12) & 0xf;
		check = (move >> 16) & 1;
		prom = (move >> 17) & 7;
		S = "";
		int from_file = 1 + (move & 7),
		    from_rank = 1 + ((move >> 3) & 7),
		    to_file = 1 + ((move >> 6) & 7),
		    to_rank = 1 + ((move >> 9) & 7);
		cap = ((type >= 1 && type <= 6) || (type == 8));
		piece = AT[from_file][from_rank];
		if (piece == 1 || piece == -1)
		    {
			if (cap)
			    S = "" + (char) (from_file + 'a' - 1) + "x";
			S += "" + (char) (to_file + 'a' - 1) + "" + to_rank;
			if (prom >= 2)
			    S += "=" + CF.PIECE_STRING.substring (6 - prom, 7 - prom);
		    }
		else
		    {
			if (piece == 6 || piece == -6)
			    S = CF.PIECE_STRING.substring (0, 1);
			if (piece == 5 || piece == -5)
			    S = CF.PIECE_STRING.substring (1, 2);
			if (piece == 4 || piece == -4)
			    S = CF.PIECE_STRING.substring (2, 3);
			if (piece == 3 || piece == -3)
			    S = CF.PIECE_STRING.substring (3, 4);
			if (piece == 2 || piece == -2)
			    S = CF.PIECE_STRING.substring (4, 5);
			int u = (move_list[i] >> 6) & 63;
			boolean same_file = false, same_rank = false, yes = false;
			for (int j = 0; j < COUNT_OF_LEGAL_MOVES && (!same_rank || !same_file);j++)
			    {
				if (j == i)
				    continue;
				int v = move_list[j];
				if (((v >> 6) & 63) == u && AT[1 + (v & 7)][1 + ((v >> 3) & 7)] == piece)
				    {
					yes = true;
					if ((1 + (v & 7)) == from_file)
					    same_file = true;
					if ((1 + ((v >> 3) & 7)) == from_rank)
					    same_rank = true;
				    }
			    }
			if (yes)
			    {
				if (same_rank || !same_file)
				    S += (char) (from_file + 'a' - 1);
				if (same_file)
				    S += from_rank;
			    }
			if (cap)
			    S += "x";
			S += (char) (to_file + 'a' - 1) + "" + to_rank;
		    }
		move_list_annotated[i] = new String (S);
	    }
    }


    public boolean IsOK ()
    {
	return true;
    }


    public int NotateComparison (String S)
    {
	for (int i = 0; i < COUNT_OF_LEGAL_MOVES; i++)
	    if (S.equals (move_list_annotated[i]))
		return i;
	return -1;
    }

    public void MakeEP (int from_file, int to_file)
    {
	if (WTM)
	    {
		AT[from_file][5] = 0;
		AT[to_file][6] = 1;
		AT[to_file][5] = 0;
	    }
	else
	    {
		AT[from_file][4] = 0;
		AT[to_file][3] = -1;
		AT[to_file][4] = 0;
	    }
    }

    public String GetDirect (int MOVE)
    {
        int mv = MOVE & 0xffff;
        int prom = (MOVE >> 17) & 0x7;
        int from_file = 1 + (mv & 7), from_rank = 1 + ((mv >> 3) & 7),
            to_file = 1 + ((mv >> 6) & 7), to_rank = 1 + ((mv >> 9) & 7);
        String direct = new String ("");
        direct += (char) ('a' + (char) (from_file - 1));
        direct += (char) ('1' + (char) (from_rank - 1));
        direct += (char) ('a' + (char) (to_file - 1));
        direct += (char) ('1' + (char) (to_rank - 1));
        if (prom > 0)
            {
                if (prom == 2)
                    direct += 'n';
                if (prom == 3)
                    direct += 'b';
                if (prom == 4)
                    direct += 'r';
                if (prom == 5)
                    direct += 'q';
                if (prom == 6)
                    direct += 'k';
            }
	return direct;
    }

    public void MakeMove (int w)
    {
	MakeMove32 (move_list[w], move_list_annotated[w],
		    COUNT_OF_LEGAL_MOVES == 1);
    }

    public void DisAttendMove32 (int mv)
    {
	UnMakeMove32 (mv);
	MakeNormal ();
    }

    public void UnMakeMove32 (int mv)
    {
	int move = mv & 07777;
	int from_file = 1 + (move & 7), from_rank = 1 + ((move >> 3) & 7),
	    to_file = 1 + ((move >> 6) & 7), to_rank = 1 + ((move >> 9) & 7);
	int piece = AT[to_file][to_rank];
	int type = (mv >> 12) & 0xf;
	int prom = (mv >> 17) & 7;
	int OoOoO = (mv >> 20) & 0xf;
	int ct = (mv >> 24) & 127;
	WTM = !WTM;
	AT[from_file][from_rank] = piece;
	if (prom != 0)
	    AT[from_file][from_rank] = WTM ? 1 : -1;
	AT[to_file][to_rank] = 0;
	if (type >= 1 && type <= 6)
	    AT[to_file][to_rank] = WTM ? -type : type;
	if (type == 8)
	    {
		if (WTM)
		    AT[to_file][to_rank - 1] = -1;
		else
		    AT[to_file][to_rank + 1] = 1;
	    }
	if (ct >= 110)
	    {
		EnPassant = ct - 110;
		ReversibleCount = 0;
	    }
	else
	    {
		EnPassant = 0;
		ReversibleCount = ct;
	    }
	if (!WTM)
	    MOVE_NUMBER--;
    }

    public void MakeMove32 (int mv, String S, boolean forced)
    {
	int move = mv & 0xffff;
	int prom = (mv >> 17) & 7;
	int from_file = 1 + (move & 7), from_rank = 1 + ((move >> 3) & 7),
	    to_file = 1 + ((move >> 6) & 7), to_rank = 1 + ((move >> 9) & 7);
	int piece = AT[from_file][from_rank];
	boolean ep = (((move >> 12) & 8) == 8);
	int ct = (EnPassant > 0) ? (EnPassant + 110) :
	                    ((ReversibleCount > 100) ? 100 : ReversibleCount);
	if (piece == 1 || piece == -1 || AT[to_file][to_rank] != 0)
	    ReversibleCount = 0;
	else
	    ReversibleCount++;
	if (ep)
	    {
		MakeEP (from_file, to_file);
		piece = WTM ? 1 : -1;
	    }
	else
	    {
		piece = AT[from_file][from_rank];
		AT[to_file][to_rank] = AT[from_file][from_rank];
		AT[from_file][from_rank] = 0;
	    }
	EnPassant = 0;
	if (prom > 0)
	    {
		if (WTM)
		    AT[to_file][to_rank] = prom;
		else
		    AT[to_file][to_rank] = -prom;
	    }
	if (piece == 1 && to_rank == 4 && from_rank == 2)
	    {
		if (from_file > 1 && AT[from_file -1][4] == -1)
		    EnPassant = from_file;
		if (from_file < 8 && AT[from_file + 1][4] == -1)
		    EnPassant = from_file;
	    }
	if (piece == -1 && to_rank == 5 && from_rank == 7)
	    {
		if (from_file > 1 && AT[from_file - 1][5] == 1)
		    EnPassant = from_file;
		if (from_file < 8 && AT[from_file + 1][5] == 1)
		    EnPassant = from_file;
	    }
	WTM = !WTM;
	if (WTM)
	    MOVE_NUMBER++;	
    }
 }
 
// 0-11 to-from, 12-15 type/ep, 16 is_check, 17-19 prom
// 20-23 prior castling, 24-30 prior count
