
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;

public class ComradesFrame
    implements ChangeListener,MouseListener, ActionListener, FocusListener
{
    BoardPanel BOARD_PANEL;
    MovePane MOVE_PANE;
    JPanel BOARD_PANEL_COLLECTIVE, MOVE_PANE_COLLECTIVE; // all
    Font chess_font;
    Font chess_font_small;
    String FONT_FILE_NAME;
    String RUN_COMMAND;
    int SIZE,NODE_COUNT=1000000;
    int CPU_COUNT=0,SS=0,TIME=0;
    boolean UTILITY=false;
    boolean QUERY=false;
    boolean CLUSTER=false;
    MyCheckBox CHECK_BOXES[]; int cb;
    JButton CPUS_BUTTON,SS_BUTTON,TIME_BUTTON,SAVE_BUTTON;
    JButton INFO_BUTTON,SLAVE_BUTTON;
    JFrame j_frame;
    JTextArea TEXT_INFO;
    JScrollPane TEXT_INFO_JSP;
    JTextField FEN_AREA;
    JLabel COUNT_LABEL,TB_LABEL;
    JButton FEN_BUTTON, CALC_BUTTON, SPIN_BUTTON;
    boolean TABLEBASES=true;
    boolean POSITION_SEND = false;
    boolean LOAD_INSTANCE = false;
    boolean[] INSTANCES_ON_COPY;
    int NUMBER_OF_MOVES = 0;
    int COMMUNICATOR_COUNT;
    int QUEUE_COUNT = 0;
    int WORKING_COUNT = 0;
    CommunicatorInstance COMM_INST = null;
    int instances;
    boolean READY_OK = false;
    boolean CHANGING_INSTANCES;
    Box INSTANCE_BOX;
    Color WHITE_PIECES, BLACK_PIECES, LIGHT_SQUARES, DARK_SQUARES;
    Color BACK_GROUND;
    Color CASTLING_COLOR, MOVE_ARROWS, YELLOW_BUTTON, CLICKED_COLOR;
    Color WHITE_MOVE_INDICATOR, BLACK_MOVE_INDICATOR, EN_PASSANT_COLOR;
    boolean WHITE_ALL_OUTLINE, BLACK_ALL_OUTLINE;
    boolean WHITE_HALF_OUTLINE, BLACK_HALF_OUTLINE;
    boolean WHITE_MATERIAL_OUTLINE, BLACK_MATERIAL_OUTLINE;
    Color SMALL_WHITE_PIECES, SMALL_BLACK_PIECES, SMALL_LIGHT_SQUARES, SMALL_DARK_SQUARES;
    Color SMALL_BACK_GROUND, SMALL_WHITE_MOVE_INDICATOR, SMALL_BLACK_MOVE_INDICATOR, SMALL_EN_PASSANT_COLOR;
    boolean SMALL_WHITE_ALL_OUTLINE, SMALL_BLACK_ALL_OUTLINE;
    boolean SMALL_WHITE_HALF_OUTLINE, SMALL_BLACK_HALF_OUTLINE;
    boolean SMALL_WHITE_MATERIAL_OUTLINE, SMALL_BLACK_MATERIAL_OUTLINE;
    File PGN_FILE = null; // recur
    String PIECE_STRING;
    String BOOK_NAME;
    boolean USE_TB, WIN_TREE;

    public ComradesFrame
    (String BN,boolean use_TB,boolean win_tree,boolean cluster,boolean util)
    {
	BOOK_NAME = new String(BN); USE_TB=use_TB; WIN_TREE=win_tree;
	CLUSTER=cluster; UTILITY=util;
	SetColors ();
	CHECK_BOXES = new MyCheckBox[256]; cb=0;
	SIZE = 40;
	MOVE_PANE = new MovePane (new JPanel ());
	BOARD_PANEL = new BoardPanel (new BoardPosition (this, MOVE_PANE));
	String FEN_STRING = BOARD_PANEL.POS.GetFEN ();
	BOARD_PANEL.setSize (10 * SIZE, 10 * SIZE);
	MakeFrame ();
	FEN_AREA.setText (FEN_STRING);
	redraw();
	COMMUNICATOR_COUNT = 0;
	instances = 0;
	INSTANCES_ON_COPY = new boolean[256];
	for (int i = 0; i < 256; i++) INSTANCES_ON_COPY[i] = false;
    }
    
    public void SetColors ()
    {
	WHITE_PIECES = new Color (250, 240, 225);
        BLACK_PIECES = new Color (25, 15, 10);
	LIGHT_SQUARES = new Color (150, 170, 190);
        DARK_SQUARES = new Color (140, 120, 100);
	BACK_GROUND = new Color (180, 180, 180);
	CASTLING_COLOR = new Color (128, 96, 64);
        MOVE_ARROWS = new Color (32, 32, 255);
        YELLOW_BUTTON = Color.yellow;
        CLICKED_COLOR = Color.red;
        WHITE_MOVE_INDICATOR = Color.white;
        BLACK_MOVE_INDICATOR = Color.black;
        EN_PASSANT_COLOR = Color.orange;
	WHITE_ALL_OUTLINE = BLACK_ALL_OUTLINE = false;
	WHITE_HALF_OUTLINE = BLACK_HALF_OUTLINE = false;
	WHITE_MATERIAL_OUTLINE = BLACK_MATERIAL_OUTLINE = false;
	SMALL_WHITE_PIECES = Color.white;
	SMALL_BLACK_PIECES = Color.black;
	SMALL_LIGHT_SQUARES = Color.white;
	SMALL_DARK_SQUARES = Color.cyan;
	SMALL_BACK_GROUND = new Color (230, 190, 180);
	SMALL_WHITE_MOVE_INDICATOR = Color.white;
	SMALL_BLACK_MOVE_INDICATOR = Color.black;
	SMALL_EN_PASSANT_COLOR = Color.orange;
	SMALL_WHITE_ALL_OUTLINE = true;
	SMALL_BLACK_ALL_OUTLINE = false;
	SMALL_WHITE_HALF_OUTLINE = false;
	SMALL_BLACK_HALF_OUTLINE = false;
	SMALL_WHITE_MATERIAL_OUTLINE = true;
	SMALL_BLACK_MATERIAL_OUTLINE = false;
	FONT_FILE_NAME = new String ("MERIFONT.TTF"); // HACK
	PIECE_STRING = new String ("KQRBNP");
    }

    public void redraw ()
    {
	if (!READY_OK)
	    return;
	BOARD_PANEL.repaint();
	TEXT_INFO.repaint ();
	JScrollBar JSB = TEXT_INFO_JSP.getVerticalScrollBar ();
	JSB.setValue (JSB.getMaximum () - 12); // HACK
	JSB.repaint ();
    }
    

////////////////////////////////////////////////////////////////

    public void DoComradesOption (String S)
    {
	StringTokenizer ST = new StringTokenizer (S);
	String N = ST.nextToken ();
	String V = ST.nextToken ();
	if (N.equals ("WhitePieces"))
	    WHITE_PIECES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("BlackPieces"))
	    BLACK_PIECES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("LightSquares"))
	    LIGHT_SQUARES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("DarkSquares"))
	    DARK_SQUARES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("BackGround"))
	    BACK_GROUND = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("CastlingColor"))
	    CASTLING_COLOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("EnPassantColor"))
	    EN_PASSANT_COLOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("MoveArrows"))
	    MOVE_ARROWS = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("YellowButton"))
	    YELLOW_BUTTON = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("WhiteMoveIndicator"))
	    WHITE_MOVE_INDICATOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("BlackMoveIndicator"))
	    BLACK_MOVE_INDICATOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("WhiteAllOutline"))
	    WHITE_ALL_OUTLINE = V.equals ("true");
	if (N.equals ("BlackAllOutline"))
	    BLACK_ALL_OUTLINE = V.equals ("true");
	if (N.equals ("WhiteHalfOutline"))
	    WHITE_HALF_OUTLINE = V.equals ("true");
	if (N.equals ("BlackHalfOutline"))
	    BLACK_HALF_OUTLINE = V.equals ("true");
	if (N.equals ("WhiteMaterialOutline"))
	    WHITE_MATERIAL_OUTLINE = V.equals ("true");
	if (N.equals ("BlackMaterialOutline"))
	    BLACK_MATERIAL_OUTLINE = V.equals ("true");

	if (N.equals ("SmallWhitePieces"))
	    SMALL_WHITE_PIECES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallBlackPieces"))
	    SMALL_BLACK_PIECES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallLightSquares"))
	    SMALL_LIGHT_SQUARES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallDarkSquares"))
	    SMALL_DARK_SQUARES = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallBackGround"))
	    SMALL_BACK_GROUND = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallEnPassantColor"))
	    SMALL_EN_PASSANT_COLOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallWhiteMoveIndicator"))
	    SMALL_WHITE_MOVE_INDICATOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallBlackMoveIndicator"))
	    SMALL_BLACK_MOVE_INDICATOR = new Color (Integer.valueOf (V).intValue (), true);
	if (N.equals ("SmallWhiteAllOutline"))
	    SMALL_WHITE_ALL_OUTLINE = V.equals ("true");
	if (N.equals ("SmallBlackAllOutline"))
	    SMALL_BLACK_ALL_OUTLINE = V.equals ("true");
	if (N.equals ("SmallWhiteHalfOutline"))
	    SMALL_WHITE_HALF_OUTLINE = V.equals ("true");
	if (N.equals ("SmallBlackHalfOutline"))
	    SMALL_BLACK_HALF_OUTLINE = V.equals ("true");
	if (N.equals ("SmallWhiteMaterialOutline"))
	    SMALL_WHITE_MATERIAL_OUTLINE = V.equals ("true");
	if (N.equals ("SmallBlackMaterialOutline"))
	    SMALL_BLACK_MATERIAL_OUTLINE = V.equals ("true");
	if (N.equals ("FontFile"))
	    FONT_FILE_NAME = new String (V);
	if (N.equals ("PieceString"))
	    PIECE_STRING = new String (V);
    }

////////////////////////////////////////////////////////////////

    public void mouseEntered (MouseEvent mou_evt)
    {
	if (mou_evt.getComponent () == FEN_AREA)
	    BOARD_PANEL.POS.MOVE_TREE.FOCUS = false;
	FEN_AREA.requestFocus ();
    }
    public void mouseExited (MouseEvent mou_evt) { }
    public void mousePressed (MouseEvent mou_evt) { }
    public void mouseReleased (MouseEvent mou_evt) { }
    public void mouseClicked (MouseEvent mou_evt) { }

    public void BoardPositionChanged ()
    {
	BOARD_PANEL.CLICKED = false;
	FEN_AREA.setText (BOARD_PANEL.POS.GetFEN ()); // HACK
	if (COMM_INST!=null) COMM_INST.Query();
    }

    public void ParseFEN (String FEN_STRING) // for the BOARD_POSITION ?
    {
	BOARD_PANEL.POS.SetFEN (new StringTokenizer (FEN_STRING));
	BOARD_PANEL.POS.NewMoveTree ();
	BOARD_PANEL.POS.MOVE_TREE.PaintPanel ();
	BoardPositionChanged ();
	BOARD_PANEL.repaint ();
    }

    public void DealCards (String S)
    {
	CardLayout CL; // HACK
	CL = (CardLayout) (BOARD_PANEL_COLLECTIVE.getLayout ());
	CL.show (BOARD_PANEL_COLLECTIVE, S);
	CL = (CardLayout) (MOVE_PANE_COLLECTIVE.getLayout ());
	CL.show (MOVE_PANE_COLLECTIVE, S);
	TidyCards ();
    }

    public void TidyCards () // HACK
    {
	for (int i = 0; i < BOARD_PANEL_COLLECTIVE.getComponentCount (); i++)
	    if (BOARD_PANEL_COLLECTIVE.getComponent (i).isVisible ())
		BOARD_PANEL = (BoardPanel) (BOARD_PANEL_COLLECTIVE.getComponent (i));
	for (int i = 0; i < MOVE_PANE_COLLECTIVE.getComponentCount (); i++)
	    if (MOVE_PANE_COLLECTIVE.getComponent (i).isVisible ())
		MOVE_PANE = (MovePane) (MOVE_PANE_COLLECTIVE.getComponent (i));
	BoardPositionChanged ();
	BOARD_PANEL.POS.MOVE_TREE.FOCUS = true;
	BOARD_PANEL.POS.MOVE_TREE.PaintPanel (); // HACK
	redraw ();	
    }

    public void ForWardCards ()
    {
	CardLayout CL; // HACK
	CL = (CardLayout) (BOARD_PANEL_COLLECTIVE.getLayout ());
	CL.next (BOARD_PANEL_COLLECTIVE);
	CL = (CardLayout) (MOVE_PANE_COLLECTIVE.getLayout ());
	CL.next (MOVE_PANE_COLLECTIVE);
	TidyCards ();
    }

    public void BackWardCards ()
    {
	CardLayout CL; // HACK
	CL = (CardLayout) (BOARD_PANEL_COLLECTIVE.getLayout ());
	CL.previous (BOARD_PANEL_COLLECTIVE);
	CL = (CardLayout) (MOVE_PANE_COLLECTIVE.getLayout ());
	CL.previous (MOVE_PANE_COLLECTIVE);
	TidyCards ();
    }

    public void Expand(String S)
    {
	StringBuffer SB=new StringBuffer(S);
	if (S.equals("NULL"))
	{BOARD_PANEL.MakeNull(); BOARD_PANEL.repaint(); return;}
	int cx=(int) (SB.charAt(0)-'a'+1);
	int cy=(int) (SB.charAt(1)-'1'+1);
	int x=(int) (SB.charAt(2)-'a'+1);
	int y=(int) (SB.charAt(3)-'1'+1);
	int cb=1,b=1;
	if (SB.length()>4)
	    {
		if (SB.charAt(4)=='k') {cb=1; b=3;}
		if (SB.charAt(4)=='n') {cb=2; b=1;}
		if (SB.charAt(4)=='b') {cb=2; b=2;}
		if (SB.charAt(4)=='r') {cb=2; b=3;}
	    }
	BOARD_PANEL.TryMove(cx,cy,cb,x,y,b);
	BOARD_PANEL.repaint();
    }

    public String GetPath()
    {
	MoveTree MT = BOARD_PANEL.POS.MOVE_TREE;
        BoardPosition BP = new BoardPosition (MT.START); // copy   
	//        if (!BP.GetFEN().equals
	//           ("rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w - - 0 1"))
	//	    return null;
        ComradesNode N= MT.ROOT; String S="";
        while (N != MT.NOW)
            { BP.MakeMove32 (N.mainline.move, N.mainline.fancy, false);
                S += " " + BP.GetDirect (N.mainline.move);
                N = N.MainLineNode; }
	return S;
    }

    public void IncludeAllMoves()
    {
	if (!USE_TB) return;
	String S=GetPath();
	if (COMM_INST!=null) COMM_INST.SendTo("includeall " + S,true);
	if (COMM_INST!=null) COMM_INST.Query();
    }

    public void Spawn(String X)
    {
	if (!USE_TB) return;
	String S=GetPath();
	if (COMM_INST!=null)
	    {
		if (CLUSTER) COMM_INST.SendTo("queue"+S+" "+X,true);
		else COMM_INST.SendTo("spawn 97 " + S + " " + X,true);
	    }
    }

    
    public void stateChanged (ChangeEvent e) {}
    public JSpinner GetSpinner (String S, int def, int min, int max, Box BOX)
    {Box B = new Box (BoxLayout.X_AXIS); JLabel L = new JLabel (S + ":  ");
     L.setBackground (new Color (205, 195, 235)); B.add (L);
     SpinnerNumberModel MODEL = new SpinnerNumberModel (def, min, max, 1);
     JSpinner J = new JSpinner (MODEL);
     J.setName (S); J.addChangeListener (this); // HACK
     J.setPreferredSize (new Dimension (80, 16));
     J.setMaximumSize (new Dimension (80, 16)); B.add (J);
     JLabel M = new JLabel ("  min " + min + " max " + max);
     M.setFont (new Font ("Monospaced", 0, 12)); B.add (M);
     B.setAlignmentX (0.05f); BOX.add (B); return J;}

    JSpinner CPU_SPINNER,SS_SPINNER,TIME_SPINNER;
    JFrame CHANGES_FRAME;
    public void MakeChangesFrame(JFrame F)
    {Box BOX = new Box (BoxLayout.Y_AXIS);
     CPU_SPINNER=GetSpinner("CPUs",CPU_COUNT,0,64,BOX);
     SS_SPINNER=GetSpinner("Search Size",SS,0,100,BOX);
     TIME_SPINNER=GetSpinner("Time Limit",TIME,0,100,BOX);
     JButton OK_BUTTON = new JButton("OK");
     OK_BUTTON.setActionCommand("changes");
     OK_BUTTON.addActionListener(this);
     BOX.add(OK_BUTTON); F.add(BOX);}

    public void TryLoadSlaves()
    {
        File file = new File ("ClusterGUI.config");
        if (!file.exists ()) return;
	System.out.println("Reading slaves from ClusterGUI.config");
        BufferedReader BR;
        try {   FileReader FR = new FileReader (file);
                BR = new BufferedReader (FR);
                while (BR.ready ()) do_new_slave (BR.readLine ());
		BR.close (); }
        catch (IOException io_e) {}
    }

    public void DoChanges()
    {COMM_INST.SendTo("setcpus "+CPU_SPINNER.getValue(),true);
     COMM_INST.SendTo("searchsize "+SS_SPINNER.getValue()+"000000",true);
     COMM_INST.SendTo("timelimit "+TIME_SPINNER.getValue(),true);
     try {Thread.sleep(25);} catch (InterruptedException e) {}
     CHANGES_FRAME.setVisible(false); CHANGES_FRAME.dispose();
     CHANGES_FRAME=null;}

    public void ChangesFrame()
    {if (CHANGES_FRAME!=null) return; CHANGES_FRAME=new JFrame("Make changes");
     MakeChangesFrame(CHANGES_FRAME);
     CHANGES_FRAME.addWindowListener(new WindowAdapter()
      {public void windowClosing(WindowEvent w) {CHANGES_FRAME=null;}});
     CHANGES_FRAME.setBackground(Color.lightGray);
     CHANGES_FRAME.pack(); CHANGES_FRAME.setSize(300,200);
     CHANGES_FRAME.setResizable(false); CHANGES_FRAME.setVisible(true);}

    public void do_new_slave(String S)
    {if (S==null) return; COMM_INST.SendTo(S,true);
     COMM_INST.WaitForThroughPut("DONE WITH REGISTER",100000,true);}

    public void NewSlave()
    {JTextField J=new JTextField(80); JPanel panel=new JPanel(); panel.add(J);
     int r=JOptionPane.showConfirmDialog
	 (null, panel, "Slave Command",JOptionPane.OK_CANCEL_OPTION);
     if (r==JOptionPane.OK_OPTION) do_new_slave(J.getText().trim());}

    public void SlaveControl()
    {COMM_INST.SendTo("listslaves",true);
     COMM_INST.WaitForThroughPut("SLAVE LIST",100000,true);
     double WIDE_POWER=2.0,WIDE_LIMIT=30.0;
     Box B=new Box(BoxLayout.Y_AXIS);
     JCheckBox JCB[]=new JCheckBox[64]; int num=0;
     while (true)
     {String S=COMM_INST.NextLine();
      if (!S.startsWith("status"))
      {JCB[num]=new JCheckBox(S,null,true);
       JCB[num].setAlignmentX(Component.LEFT_ALIGNMENT);
       B.add(JCB[num++]); continue;}
      StringTokenizer ST=new StringTokenizer(S); ST.nextToken();
      QUEUE_COUNT=Integer.valueOf(ST.nextToken()).intValue();
      WORKING_COUNT=Integer.valueOf(ST.nextToken()).intValue();       
      WIDE_POWER=Double.parseDouble(ST.nextToken());
      WIDE_LIMIT=Double.parseDouble(ST.nextToken()); break;}
      SpinnerNumberModel M1=new SpinnerNumberModel(WIDE_POWER,1.0,3.0,0.01);
      SpinnerNumberModel M2=new SpinnerNumberModel(WIDE_LIMIT,1.0,1000.0,1.0);
      Box B1=new Box(BoxLayout.X_AXIS);
      JSpinner J1=new JSpinner(M1); J1.setName("WidthPower");
      J1.setPreferredSize (new Dimension (55, 16));
      J1.setMaximumSize (new Dimension (55, 16));
      JLabel L1=new JLabel("WidthPower: "); B1.add(L1); B1.add(J1);
      Box B2=new Box(BoxLayout.X_AXIS);
      JSpinner J2=new JSpinner(M2); J2.setName("WidthLimit");
      J2.setPreferredSize (new Dimension (55, 16));
      J2.setMaximumSize (new Dimension (55, 16));
      JLabel L2=new JLabel("WidthLimit:  "); B2.add(L2); B2.add(J2);
      B1.setAlignmentX(Component.LEFT_ALIGNMENT); B.add(B1);
      B2.setAlignmentX(Component.LEFT_ALIGNMENT); B.add(B2);
      JPanel JP=new JPanel(); JP.add(B); Object[] options={"NewSlave","OK"};
      int r=JOptionPane.showOptionDialog
	  (null,JP, "Slave Configuration",JOptionPane.YES_NO_OPTION,
	   JOptionPane.PLAIN_MESSAGE,null,options,options[1]);
      System.out.println(r+" "+JOptionPane.NO_OPTION);
      if (r==JOptionPane.CLOSED_OPTION) return;
      if (r==JOptionPane.YES_OPTION) {NewSlave(); return;}
      if (r!=JOptionPane.NO_OPTION) return;
      COMM_INST.SendTo("widepower "+J1.getValue(),true);
      COMM_INST.SendTo("widelimit "+J2.getValue(),true);
      for (int j=0;j<num;j++) if (!JCB[j].isSelected())
      {COMM_INST.SendTo("byeslave "+JCB[j].getText().substring(6),true);}
    }

    public void do_search()
    {String S=GetPath(); while (COMM_INST.IsReady()) COMM_INST.DemandLine();
     COMM_INST.SendTo("search "+NODE_COUNT+" "+S,true);
     JFrame of=new JFrame("Search results");
     JTextArea A=new JTextArea(60,60); A.setEditable(false);
     A.setFont(new Font("Monospaced",0,11)); of.add(A);
     of.setBackground(Color.lightGray); of.pack();
     of.setSize(600,300+10*BOARD_PANEL.POS.COUNT_OF_LEGAL_MOVES);
     of.setResizable(false); of.setVisible(true);
     while (true)
     {while (!COMM_INST.IsReady()) COMM_INST.SleepFor(10);
      String L=COMM_INST.DemandLine(); if (L.equals("Done with input")) break;
      A.append(L+"\n"); A.update(A.getGraphics());}}

    public void do_prune() // switch to root
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine();
     COMM_INST.SendTo("prune",true);
     BOARD_PANEL.POS.MOVE_TREE.JumpToNode(BOARD_PANEL.POS.MOVE_TREE.ROOT);}

    public void do_subtree()
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine(); boolean b=false;
     int u; for (u=0;u<cb;u++) if (!CHECK_BOXES[u].isSelected()) b=true;
     if (!b) COMM_INST.SendTo("subtree " + GetPath(),true);
     else
     {b=false; for (u=0;u<cb;u++) if (CHECK_BOXES[u].isSelected()) b=true;
      if (!b) {System.out.println("At least 1 box must be selected"); return;}
      b=false; for (u=0;u<cb;u++) if (!CHECK_BOXES[u].isSelected()) b=true;
      if (!b) {System.out.println("At least 1 box must be unselected");return;}
      COMM_INST.SendTo("excludesetup " + GetPath(),true);
      String S=new String("subexclude");
      for (u=0;u<cb;u++)
	  if (!CHECK_BOXES[u].isSelected()) S+=" "+CHECK_BOXES[u].S;
      COMM_INST.SendTo(S,true);} COMM_INST.Query();}

    public void do_exclude()
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine(); boolean b; int u;
     b=false; for (u=0;u<cb;u++) if (CHECK_BOXES[u].isSelected()) b=true;
     if (!b) {System.out.println("At least 1 box must be selected"); return;}
     b=false; for (u=0;u<cb;u++) if (!CHECK_BOXES[u].isSelected()) b=true;
     if (!b) {System.out.println("At least 1 box must be unselected"); return;}
     COMM_INST.SendTo("excludesetup " + GetPath(),true);
     String S=new String("excludemoves");
     for (u=0;u<cb;u++)
	 if (!CHECK_BOXES[u].isSelected()) S+=" "+CHECK_BOXES[u].S;
     COMM_INST.SendTo(S,true); COMM_INST.Query();}

    public void do_loadbook() // relative path is too hard
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine(); boolean b; int u;
     String S=new String("loadbook ");
     JFileChooser J; J=new JFileChooser(new File("BOOKS/"));
     int v=J.showOpenDialog(J);
     if (v!=JFileChooser.APPROVE_OPTION) return;
     File F=J.getSelectedFile(); if (!F.exists()) return;
     String U=F.getPath(); COMM_INST.SendTo(S+U,true);
     BOARD_PANEL.POS.NewGame(); BOARD_PANEL.repaint();
     BOARD_PANEL.POS.MOVE_TREE.ReSet(); BOARD_PANEL.POS.MOVE_TREE.repaint();
     BOARD_PANEL.POS.MOVE_TREE.JumpToNode(BOARD_PANEL.POS.MOVE_TREE.ROOT);
     COMM_INST.Query();} // hopefully this is right

    public void do_merge() // relative path is too hard
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine(); boolean b; int u;
     String S=new String("merge ");
     JFileChooser J; J=new JFileChooser(new File("BOOKS/"));
     int v=J.showOpenDialog(J);
     if (v!=JFileChooser.APPROVE_OPTION) return;
     File F=J.getSelectedFile(); if (!F.exists()) return;
     String U=F.getPath(); COMM_INST.SendTo(S+U,true);
     JFrame of=new JFrame("Output from merging");
     JTextArea A=new JTextArea(80,60); A.setEditable(false);
     A.setFont(new Font("Monospaced",0,11));
     JScrollPane JSP=new JScrollPane(A); of.add(JSP);
     of.setBackground(Color.lightGray); of.pack(); of.setSize(600,600);
     of.setResizable(false); of.setVisible(true);
     while (true)
     {while (!COMM_INST.IsReady()) COMM_INST.SleepFor(10);
      String L=COMM_INST.DemandLine(); if (L.equals("Done with input")) break;
      A.append(L+"\n"); A.repaint();}
     BOARD_PANEL.POS.NewGame(); BOARD_PANEL.repaint();
     BOARD_PANEL.POS.MOVE_TREE.ReSet(); BOARD_PANEL.POS.MOVE_TREE.repaint();
     BOARD_PANEL.POS.MOVE_TREE.JumpToNode(BOARD_PANEL.POS.MOVE_TREE.ROOT);
     COMM_INST.Query();} // hopefully this is right

    public void do_wintree()
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine();
     COMM_INST.SendTo("wintree "+GetPath(),true);
     JFrame of=new JFrame("Wintree results");
     JTextArea A=new JTextArea(80,60); A.setEditable(false);
     A.setFont(new Font("Monospaced",0,11));
     JScrollPane J=new JScrollPane(A); of.add(J);
     of.setBackground(Color.lightGray); of.pack(); of.setSize(600,600);
     of.setResizable(false); of.setVisible(true);
     while (true)
     {while (!COMM_INST.IsReady()) COMM_INST.SleepFor(10);
      String L=COMM_INST.DemandLine(); if (L.equals("Done with input")) break;
      A.append(L+"\n"); A.update(A.getGraphics());}}

    public void do_goodbad(int g,int b,String S)
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine();
     COMM_INST.SendTo("goodbad "+g+" "+b+" "+GetPath()+" "+S,true);
     COMM_INST.Query();}

    public void do_null()
    {while (COMM_INST.IsReady()) COMM_INST.DemandLine(); Expand("NULL");}


    public void actionPerformed (ActionEvent act_evt)
    {
	String S = act_evt.getActionCommand ();
	if (S.equals("changes")) DoChanges();
	if (S.equals ("SaveBook") &&
	    ((act_evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0))
	    {do_loadbook(); return;}
	if (S.equals ("SaveBook")) {COMM_INST.SaveBook();}
	if (S.equals ("Include")) IncludeAllMoves();
	if (S.equals("spinloop")) COMM_INST.SpinLoop();
	if (S.equals("newslave")) NewSlave();
	if (S.equals("slavecontrol")) SlaveControl();
	if (S.equals("search"))
	{if ((act_evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
	 {SpinnerNumberModel M=
	      new SpinnerNumberModel(NODE_COUNT,100000,1000000000,1);
	  JSpinner A=new JSpinner(M); A.setName("NodeCount");
	  JPanel P=new JPanel(); P.add(A);
	  int r=JOptionPane.showConfirmDialog
	      (null,P,"NodeCount",JOptionPane.OK_CANCEL_OPTION);
	  if (r!=JOptionPane.OK_OPTION) return;
	  NODE_COUNT=Integer.valueOf(A.getValue().toString()).intValue();}
	 do_search();
	}
	if (S.equals("loadbook")) do_loadbook();
	if (S.equals("prune")) do_prune();
	if (S.equals("merge")) do_merge();
	if (S.equals("subtree")) do_subtree();
	if (S.equals("exclude")) do_exclude();
	if (S.equals("wintree")) do_wintree();
	if (S.equals("NULL")) do_null();
	if (S.equals("makeroot"))
	{if ((act_evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
	 {COMM_INST.SendTo("pause",true);
	  SPIN_BUTTON.setBackground(Color.red);
	  SPIN_BUTTON.revalidate();}
	 else
	 {COMM_INST.MakeRoot();
	  SPIN_BUTTON.setBackground(Color.green);
	  SPIN_BUTTON.revalidate();}}
	if (S.startsWith("expand "))
	    {
		if ((act_evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
		    COMM_INST.SendTo
			("ignore"+GetPath()+" "+S.substring(7),true);
		else Expand(S.substring(7));
	    }
	if (S.startsWith("ignore "))
	    COMM_INST.SendTo("ignore"+GetPath()+" "+S.substring(7),true);
	if (S.equals("CPUs")) ChangesFrame();
	if (S.equals("SS")) ChangesFrame();
	if (S.equals("Time")) ChangesFrame();
	if (S.startsWith("spawn "))
	{if (UTILITY && (act_evt.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
	 {SpinnerNumberModel M1=new SpinnerNumberModel(1,1,(1<<30),1);
	  SpinnerNumberModel M2=new SpinnerNumberModel(1,1,(1<<30),1);
	  JSpinner A1=new JSpinner(M1); A1.setName("Good");
	  JSpinner A2=new JSpinner(M2); A2.setName("Bad");
	  JPanel P=new JPanel();
	  Box B1=new Box(BoxLayout.X_AXIS);
	  B1.add(new Label("Good")); B1.add(A1);
	  Box B2=new Box(BoxLayout.X_AXIS);
	  B2.add(new Label("Bad")); B2.add(A2);
	  Box B=new Box(BoxLayout.Y_AXIS);
	  B.add(B1); B.add(B2); P.add(B);
	  int r=JOptionPane.showConfirmDialog
	      (null,P,"Good/Bad",JOptionPane.OK_CANCEL_OPTION);
	  if (r!=JOptionPane.OK_OPTION) return;
	  int g=Integer.valueOf(A1.getValue().toString()).intValue();
	  int b=Integer.valueOf(A2.getValue().toString()).intValue();
	  do_goodbad(g,b,S.substring(6)); return;
	 }
	 if (UTILITY) {Expand(S.substring(6)); return;}
	 JButton B=(JButton) (act_evt.getSource());
	 B.setEnabled(false);
	 B.setText("C");
	 B.setBackground(Color.green);
	 B.revalidate();
	 Spawn(S.substring(6));
	}
    }

    public void ERROR (String STRING)
    { System.out.println (STRING); System.exit (123456); }
    
    public void InitChessFont (String S, int SIZE)
    {
	FileInputStream FIS = null;
	Font FONT = null;
	try
	    {
		FIS = new FileInputStream (S);
	    }
	catch (IOException io_e)
	    {
		ERROR ("Cannot find font file " + S);
	    }
	try
	    {
		FONT = Font.createFont (Font.TRUETYPE_FONT, FIS);
	    }
	catch (IOException io_e)
	    {
		ERROR ("IOException in font creation");
	    }
	catch (FontFormatException io_e)
	    {
		ERROR("Font format exception");
	    }
	try
	    {
		FIS.close();
	    }
	catch (IOException io_e)
	    {
		ERROR ("Failure to close fonts");
	    }
	FONT_FILE_NAME = new String (S);
	chess_font = FONT.deriveFont ((float) SIZE);
	chess_font_small = chess_font.deriveFont (16.0f); // small
    }

    public void TellInfo (String STRING)
    {
	TEXT_INFO.append (STRING + "\n");
	TEXT_INFO.setCaretPosition (TEXT_INFO.getText ().length ());
	TEXT_INFO.repaint ();
	TEXT_INFO_JSP.repaint ();
	JScrollBar JSB = TEXT_INFO_JSP.getVerticalScrollBar ();
	JSB.setValue (JSB.getMaximum ());
	JSB.repaint ();
    }

    public void focusGained (FocusEvent foc_evt)
    {
	if (BOARD_PANEL.POS.MOVE_TREE.NOW.LABEL==null) return;
	if (BOARD_PANEL.POS.MOVE_TREE.FOCUS)
	    BOARD_PANEL.POS.MOVE_TREE.NOW.LABEL.requestFocus (); // HACK
    }

    public void focusLost (FocusEvent foc_evt) // empty (null)
    {
    }

    public Box Make_FEN_Box ()
    {
	Box FEN_BOX = new Box (BoxLayout.X_AXIS);
	FEN_AREA = new JTextField (50);
	FEN_AREA.setFont (new Font ("Monospaced", 0, 9));
	FEN_AREA.setEditable (false);
	FEN_AREA.addFocusListener (this); // HACK
	FEN_AREA.addMouseListener (this); // HACK
	FEN_AREA.setPreferredSize (new Dimension (410, 20));
	FEN_AREA.setMinimumSize (new Dimension (400, 20));
	FEN_BOX.add (FEN_AREA);
	FEN_AREA.setAlignmentX (0.5f);
	FEN_BOX.setAlignmentX (0.0f); // query ?
	FEN_BOX.setPreferredSize (new Dimension (430, 20));
	FEN_BOX.setMaximumSize (new Dimension (440, 20));
	return FEN_BOX;
    }

    public JToolBar MakeToolBar ()
    {
	JToolBar TOOL_BAR = new JToolBar ();
	TOOL_BAR.setAlignmentX (0.0f); // HACK ?
	if (UTILITY)
	{
	    JButton LOAD_BUTTON,SEARCH_BUTTON,RECOMPUTE_BUTTON,PRUNE_BUTTON;
	    JButton SUBTREE_BUTTON,EXCLUDE_BUTTON,WINTREE_BUTTON,NULL_BUTTON;
	    SAVE_BUTTON = new JButton ("Save");
	    SAVE_BUTTON.setActionCommand ("SaveBook");
	    SAVE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (SAVE_BUTTON);
	    //	    LOAD_BUTTON = new JButton ("Load");
	    //	    LOAD_BUTTON.setActionCommand ("loadbook");
	    //	    LOAD_BUTTON.addActionListener (this);
	    //	    TOOL_BAR.add (LOAD_BUTTON);
	    SEARCH_BUTTON = new JButton("Search");
	    SEARCH_BUTTON.setActionCommand ("search");
	    SEARCH_BUTTON.addActionListener (this);
	    TOOL_BAR.add (SEARCH_BUTTON);
	    // RECOMPUTE_BUTTON = new JButton("Recompute");
	    // RECOMPUTE_BUTTON.setActionCommand ("recompute");
	    // RECOMPUTE_BUTTON.addActionListener (this);
	    // TOOL_BAR.add (RECOMPUTE_BUTTON);
	    PRUNE_BUTTON = new JButton("Prune");
	    PRUNE_BUTTON.setActionCommand ("prune");
	    PRUNE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (PRUNE_BUTTON);
	    SUBTREE_BUTTON = new JButton("Subtree");
	    SUBTREE_BUTTON.setActionCommand ("subtree");
	    SUBTREE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (SUBTREE_BUTTON);
	    EXCLUDE_BUTTON = new JButton("Exclude");
	    EXCLUDE_BUTTON.setActionCommand ("exclude");
	    EXCLUDE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (EXCLUDE_BUTTON);	    
	    WINTREE_BUTTON = new JButton("Wintree");
	    WINTREE_BUTTON.setActionCommand ("wintree");
	    WINTREE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (WINTREE_BUTTON);	    
	    NULL_BUTTON = new JButton("NULL");
	    NULL_BUTTON.setActionCommand ("NULL");
	    NULL_BUTTON.addActionListener (this);
	    TOOL_BAR.add (NULL_BUTTON);	    
	    JButton MERGE_BUTTON = new JButton("Merge");
	    MERGE_BUTTON.setActionCommand ("merge");
	    MERGE_BUTTON.addActionListener (this);
	    TOOL_BAR.add (MERGE_BUTTON);	    
	}
	if (WIN_TREE) return TOOL_BAR; // includes UTILITY
	// TOOL_BAR.addSeparator (); // fancy
	SAVE_BUTTON = new JButton ("SaveBook");
	SAVE_BUTTON.setActionCommand ("SaveBook");
	SAVE_BUTTON.addActionListener (this);
	TOOL_BAR.add (SAVE_BUTTON);
	JButton INCLUDE_BUTTON = new JButton ("IncludeAll");
	INCLUDE_BUTTON.setActionCommand ("Include");
	INCLUDE_BUTTON.addActionListener (this);
	//	TOOL_BAR.add (INCLUDE_BUTTON);
	TOOL_BAR.addSeparator ();
	if (CLUSTER) SPIN_BUTTON = new JButton ("MakeRoot");
	else SPIN_BUTTON = new JButton("SpinLoop");
	SPIN_BUTTON.setBackground(Color.red);
	if (CLUSTER) SPIN_BUTTON.setActionCommand ("makeroot");
	else SPIN_BUTTON.setActionCommand ("spinloop");
	SPIN_BUTTON.addActionListener (this);
	TOOL_BAR.add (SPIN_BUTTON);
	// TOOL_BAR.addSeparator ();
	COUNT_LABEL = new JLabel("0");
	COUNT_LABEL.setBackground(Color.black);
	COUNT_LABEL.setForeground(Color.red);
	COUNT_LABEL.setFont((new Font ("SansSerif", Font.BOLD, 18)));
	if (!CLUSTER) TOOL_BAR.add(COUNT_LABEL);
	if (!CLUSTER) TOOL_BAR.addSeparator ();
	TB_LABEL = new JLabel("TBs ON");
	TB_LABEL.setBackground(Color.black);
	TB_LABEL.setForeground(Color.green);
	TB_LABEL.setFont((new Font ("SansSerif", Font.BOLD, 12)));
	if (!CLUSTER) TOOL_BAR.add(TB_LABEL);
	if (!CLUSTER)
	    {
		TOOL_BAR.addSeparator ();
		CPUS_BUTTON=new JButton("0 CPUs");
		CPUS_BUTTON.setActionCommand("CPUs");
		CPUS_BUTTON.addActionListener(this);
		CPUS_BUTTON.setBackground(Color.white);
		CPUS_BUTTON.setForeground(Color.blue);
		CPUS_BUTTON.setFont(new Font("Monospaced",0,10));
		TOOL_BAR.add(CPUS_BUTTON);
		SS_BUTTON=new JButton("0M (0MB)");
		SS_BUTTON.setBackground(Color.white);
		SS_BUTTON.setForeground(Color.red);
		SS_BUTTON.setActionCommand("SS");
		SS_BUTTON.addActionListener(this);
		SS_BUTTON.setFont(new Font("Monospaced",0,10));
		TOOL_BAR.add(SS_BUTTON);
		TIME_BUTTON=new JButton("10s");
		TIME_BUTTON.setBackground(Color.white);
		TIME_BUTTON.setForeground(Color.blue);
		TIME_BUTTON.setActionCommand("Time");
		TIME_BUTTON.addActionListener(this);
		TIME_BUTTON.setFont(new Font("Monospaced",0,10));
		TOOL_BAR.add(TIME_BUTTON);
	    }
	else
	    {
		TOOL_BAR.addSeparator();
		INFO_BUTTON=new JButton("0+0 2.00 30.0");
		INFO_BUTTON.setBackground(new Color(100,200,100));
		INFO_BUTTON.setForeground(Color.black);
		INFO_BUTTON.setActionCommand("slavecontrol");
		INFO_BUTTON.addActionListener(this);
		TOOL_BAR.add(INFO_BUTTON);
		TOOL_BAR.addSeparator();
		SLAVE_BUTTON=new JButton("NewSlave");
		SLAVE_BUTTON.setActionCommand("newslave");
		SLAVE_BUTTON.addActionListener(this);
		SLAVE_BUTTON.setBackground(Color.cyan);
		SLAVE_BUTTON.setForeground(Color.black);
		TOOL_BAR.add(SLAVE_BUTTON);
	    }
	TOOL_BAR.setFloatable (false);
	return TOOL_BAR;
    }

    public void RenewContainer()
    {
	INSTANCE_BOX.removeAll(); cb=0;
	INSTANCE_BOX.revalidate();
	INSTANCE_BOX.setOpaque(true);
	INSTANCE_BOX.setBackground(new Color(200,240,200));
	INSTANCE_BOX.repaint();
    }

    public void DoProlog(String S)
    {StringTokenizer ST=new StringTokenizer(S);
     while (ST.hasMoreTokens())
     {String U=ST.nextToken();
      COMM_INST.AttendForm(U,BOARD_PANEL.POS,0);}
     BOARD_PANEL.POS.MOVE_TREE.PROLOG=BOARD_PANEL.POS.MOVE_TREE.NOW;
     ComradesNode N=BOARD_PANEL.POS.MOVE_TREE.ROOT;
     while (N!=BOARD_PANEL.POS.MOVE_TREE.NOW)
     {N.PRE_PROLOG=true; N=N.getChildAt(0);}}

    public void AddToContainer(String S)
    {
	if (S.startsWith("prolog")) {DoProlog(S.substring(7)); return;}
	if (S.startsWith("KNOWN.lock"))
	{INSTANCE_BOX.add(new JLabel("KNOWN.lock exists"));
	 INSTANCE_BOX.revalidate(); INSTANCE_BOX.repaint(); return;}
	if (S.startsWith("Move list:")) return;
	if (S.startsWith("Book size"))
	{StringTokenizer ST=new StringTokenizer(S);
	 String A=ST.nextToken(); A=ST.nextToken(); A=ST.nextToken();
	 j_frame.setTitle("ClusterGUI "+BOOK_NAME+" "+A); return;}
	if (S.startsWith("REGISTER")) return;
	if (S.startsWith("FAILED")) return;
	if (S.startsWith("Wrote to")) return;
	if (S.startsWith("New book created")) return;
	if (S.startsWith("Done with input")) return;
	if (S.startsWith("UTILITY PROGRAM")) return;
	if (S.startsWith("ERROR")) return;
	if (S.contains("SPIN_ROOT")) return;
	if (S.startsWith("Repaired")) return;
	if (S.startsWith("NEXT_PAGE")) return;
	if (S.startsWith("NEXT PAGE")) return;
	if (S.startsWith("WON")) return;
	if (S.startsWith("CPUS is"))
	{CPU_COUNT=Integer.valueOf(S.substring(8)).intValue();
         CPUS_BUTTON.setText(""+CPU_COUNT+" CPUs"); CPUS_BUTTON.repaint();
	 SS_BUTTON.setText(""+SS+"M ("+(SS*50*CPU_COUNT)+"MB)");
	 SS_BUTTON.repaint(); return;}
        if (S.startsWith("SEARCH_SIZE"))
	{SS=Integer.valueOf(S.substring(15)).intValue(); SS=SS/1000000;
	 SS_BUTTON.setText(""+SS+"M ("+(SS*50*CPU_COUNT)+"MB)");
	 SS_BUTTON.repaint(); return;}
        if (S.startsWith("TIME_LIMIT"))
	{TIME=Integer.valueOf(S.substring(14)).intValue();
	 TIME_BUTTON.setText(""+TIME+"s"); TIME_BUTTON.repaint(); return;}
	if (S.startsWith ("START") || S.startsWith("DONE")) return;
	if (S.startsWith("Starting ")) return;
	if (S.equals("CLUSTER MASTER")) return;
	if (S.startsWith ("Queue:")) return;
	if (S.contains("retire")) return; if (S.contains("search")) return;
	if (S.startsWith("status"))
	{StringTokenizer ST=new StringTokenizer(S); ST.nextToken();
	 QUEUE_COUNT=Integer.valueOf(ST.nextToken()).intValue();
	 WORKING_COUNT=Integer.valueOf(ST.nextToken()).intValue();
	 String WIDE_POWER=ST.nextToken(); String WIDE_LIMIT=ST.nextToken();
	 INFO_BUTTON.setText(WORKING_COUNT+"+"+QUEUE_COUNT+
			     " "+WIDE_POWER+" "+WIDE_LIMIT);
	 INFO_BUTTON.revalidate(); return;}
	if (S.startsWith("BOOK SAVE"))
	{SAVE_BUTTON.setBackground(Color.lightGray); SAVE_BUTTON.revalidate();}
	if (S.startsWith("SAVING BOOK"))
	{SAVE_BUTTON.setBackground(Color.yellow); SAVE_BUTTON.revalidate();}
	if (S.startsWith("BOOK") || S.startsWith("AUTO")) return;
	if (S.startsWith("ALREADY") || S.startsWith("SAVING")) return;
	if (S.startsWith("Registered")) {System.out.println(S); return;}
	if (S.startsWith("Complete")) {System.out.println(S); return;}
	if (S.startsWith("SMP loop complete"))
	{SPIN_BUTTON.setBackground(Color.cyan);
	 SPIN_BUTTON.repaint(); return;}
	if (S.startsWith("EXT")) {System.out.println(S); return;}
	if (S.startsWith("TB_Cache")) return;
	if (S.startsWith("Flat "))
        {TABLEBASES=false; TB_LABEL.setText("NO TBs");
	 TB_LABEL.setForeground(Color.red); TB_LABEL.repaint(); return;}
	if (S.startsWith("WORKING"))
        {COUNT_LABEL.setText(S.substring(8)); COUNT_LABEL.repaint(); return;}
	if (S.startsWith("No children"))
	{INSTANCE_BOX.add(new JLabel(S)); return;}
	if (S.startsWith("Cannot add"))
	{INSTANCE_BOX.add(new JLabel(S)); return;}
	if (S.startsWith("Not in BOOK") && !UTILITY)
	{INSTANCE_BOX.add(new JLabel("Not in BOOK (perhaps TRANS)")); return;}
	if (S.startsWith("Not in BOOK")) return;
	if (S.startsWith ("Val:"))
	    {
		Box BOX=new Box(BoxLayout.X_AXIS);
		StringTokenizer ST=new StringTokenizer(S);
		String X=ST.nextToken(); X=ST.nextToken();
		X = X.replace("."," ");
		JLabel L = new JLabel(X);
		Dimension D = new Dimension(10,10);
		BOX.add(new Box.Filler(D,D,D));
		BOX.add(new Box.Filler(D,D,D));
		L.setForeground(Color.red);
		L.setFont((new Font ("Serif", Font.BOLD, 14)));
		BOX.add(L);
		BOX.add(new Box.Filler(D,D,D));
		BOX.add(new Box.Filler(D,D,D));
		L=new JLabel(ST.nextToken()); L.setForeground(Color.blue);
		L.setFont((new Font ("Monospaced", 0, 12))); BOX.add(L);
		BOX.add(new Box.Filler(D,D,D));
		BOX.add(new Box.Filler(D,D,D));
		if (!WIN_TREE)
		  {
		    L=new JLabel(ST.nextToken()); L.setForeground(Color.black);
		    L.setFont((new Font ("Monospaced", 0, 12))); BOX.add(L);
		  }
		if ((ST.hasMoreTokens()) && ST.nextToken().equals("*"))
		    {
			JLabel J=new JLabel("DONE");
			J.setForeground(new Color(60,120,60));
			J.setFont((new Font ("Monospaced", 0, 12)));
			BOX.add(new Box.Filler(D,D,D));
			BOX.add(new Box.Filler(D,D,D)); BOX.add(J);
		    }
		BOX.setAlignmentX(Component.LEFT_ALIGNMENT);
		INSTANCE_BOX.add(BOX); return;
	    }
	Box BOX=new Box(BoxLayout.X_AXIS);
	StringTokenizer ST=new StringTokenizer(S);
	String M2,M=ST.nextToken();
	if (UTILITY)
	 {
	     MyCheckBox J=new MyCheckBox(M);
	     J.setSize(new Dimension(18,12));
	     J.setMaximumSize(new Dimension(18,12));
	     J.setPreferredSize(new Dimension(18,12));
	     J.setSelected(true); BOX.add(J);
	     CHECK_BOXES[cb++]=J;
	     Dimension D=new Dimension(8,8);
	     BOX.add(new Box.Filler(D,D,D));
	 }

	String V=ST.nextToken(),W=""; // second field
	int w=V.length(); if (V.contains("*")) w--;
	if (WIN_TREE && w==9 && !V.contains("In") && !V.contains("Draw")) M2=M;
	else { if (M.length()==4) M2=M+" "; else M2=M;}
	JLabel L=new JLabel(M2);
	L.setFont((new Font ("Monospaced", 0, 11))); BOX.add(L);
	Dimension D = new Dimension(8,8);
	BOX.add(new Box.Filler(D,D,D));
	if (WIN_TREE && V.contains("In")) V=V.replace("."," ");
	if (WIN_TREE && !UTILITY)
	{if (V.contains("Draw")) {W="  "; w+=2;}
	 else if (V.contains("[Win")) {W="";}
	 else if (V.contains("Win")) {W="  "; w+=2;}
	 else for (int u=w;u<8;u++) W+=" ";}
	W+=V; if (WIN_TREE && !V.contains("*")) W+=" ";
	if (UTILITY && V.contains("INF")) W+="  ";
        if (WIN_TREE && !UTILITY)
	{
	    if (V.contains("In") || V.contains("Draw"))
		for (int u=w;u<14;u++) W+=" ";
	}	
	L=new JLabel(W); L.setFont((new Font ("Monospaced", 0, 11)));
	BOX.add(L); BOX.add(new Box.Filler(D,D,D));
	String GB=ST.nextToken(); // third field
	int u=13; if (V.equals("KNOWN")) u=5;
	if (WIN_TREE && !UTILITY) u=8;
	for (;GB.length()<u;) GB+=" ";
        L=new JLabel(GB);
	L.setFont((new Font ("Monospaced", 0, 11)));
	JButton B; String sz;
	if (ST.hasMoreTokens()) sz=ST.nextToken(); else sz=new String("0");
	if (sz.equals("1"))	    
	    {
		if (CLUSTER)
		    {
			String SS=ST.nextToken();
			if (Integer.valueOf(SS).intValue()==1)
			    {
				B=new JButton("Q");
				B.setForeground(Color.black);
				B.setBackground(Color.yellow);
			    }
			else if (Integer.valueOf(SS).intValue()==2)
			    {
				B=new JButton("W");
				B.setForeground(Color.white);
				B.setBackground(Color.black);
			    }
			else
			    {
				B=new JButton("E");
				B.setForeground(Color.red);
				B.setBackground(Color.cyan);
				B.setActionCommand("spawn " + M);
				B.addActionListener(this);
			    }
		    }
		else // not CLUSTER 
		    {
			B=new JButton("E");
			B.setForeground(Color.red);
			B.setBackground(Color.cyan);
			B.setActionCommand("spawn " + M);
			B.addActionListener(this);
		    }
	    }
	else if (false && sz.contains("*"))
	    {
		B=new JButton("T");
		B.setForeground(Color.cyan);
		B.setBackground(Color.white);
	    }
	else
	    {
	        boolean b=ST.hasMoreTokens();
		String SS=null; if (b) SS=ST.nextToken();
		if (b && !SS.equals("RES") && !SS.equals("FAILED")
		    && Integer.valueOf(SS).intValue()==3)
		    {
			B=new JButton("I");
			B.setForeground(Color.black);
			B.setBackground(Color.red);
			B.setActionCommand("ignore " + M);
			B.addActionListener(this);

		    }		    
		else
		    {
			B=new JButton("F");
			B.setForeground(Color.blue);
			B.setBackground(Color.orange);
			B.setActionCommand("expand " + M);
			B.addActionListener(this);
		    }

	    }
	B.setFont(new Font("Serif",0,11));
	B.setMargin(new Insets(-3,0,-3,0));
	BOX.add(B); BOX.add(new Box.Filler(D,D,D));
	BOX.add(L); BOX.add(new Box.Filler(D,D,D));
	L=new JLabel(sz);
	L.setFont((new Font ("Monospaced", 0, 11)));
	BOX.add(L); BOX.add(new Box.Filler(D,D,D));
	BOX.setAlignmentX(Component.LEFT_ALIGNMENT);
	INSTANCE_BOX.add(BOX); return;	
    }

    public void DoGraphics ()
    {
	Box LARGE_BOX = new Box (BoxLayout.X_AXIS);
	Box LEFT_BOX = new Box (BoxLayout.Y_AXIS);
	Box RIGHT_BOX = new Box (BoxLayout.Y_AXIS);
	BOARD_PANEL_COLLECTIVE = new JPanel (new CardLayout ());
	BOARD_PANEL_COLLECTIVE.add (BOARD_PANEL, "#0: White Black *");
	BOARD_PANEL.Name = "#0: White Black *";
	LEFT_BOX.add (BOARD_PANEL_COLLECTIVE);
	MOVE_PANE_COLLECTIVE = new JPanel (new CardLayout ());
	MOVE_PANE_COLLECTIVE.add (MOVE_PANE, "#0: White Black *");
	LEFT_BOX.add (MOVE_PANE_COLLECTIVE);

	TEXT_INFO = new JTextArea (10, 50);
	TEXT_INFO.setFont (new Font("Monospaced", 0, 12));
	TEXT_INFO.setEditable (false);
	TEXT_INFO_JSP = new JScrollPane (TEXT_INFO);
	//	LEFT_BOX.add (TEXT_INFO_JSP); // in the off

	RIGHT_BOX.add (Make_FEN_Box ());
	RIGHT_BOX.add (MakeToolBar ());
	INSTANCE_BOX = new Box (BoxLayout.Y_AXIS);
	INSTANCE_BOX.add (new EmptyPanel ());
	JScrollPane INSTANCE_BOX_PANE = new JScrollPane (INSTANCE_BOX);
	INSTANCE_BOX_PANE.setHorizontalScrollBarPolicy
	    (JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	INSTANCE_BOX_PANE.setPreferredSize (new Dimension (450, 700));
	INSTANCE_BOX_PANE.setAlignmentX (0.0f);
	RIGHT_BOX.add (INSTANCE_BOX_PANE);
	RIGHT_BOX.setPreferredSize (new Dimension (450, 700));
	LARGE_BOX.add (LEFT_BOX);
	LARGE_BOX.add (RIGHT_BOX);
	j_frame.add (LARGE_BOX);
    }

    public class EmptyPanel extends JPanel // HACK
    {
	public EmptyPanel ()
	{
	}

	public void paintComponent (Graphics G) // Font exemplary
	{
	    G.setColor (Color.cyan);
	    G.fillRect (0, 0, 500, 1000);
	    G.setColor (Color.black);
	    G.setFont (chess_font.deriveFont (20.0f));
	    char[] BUFFER = new char[1];
	    int h = 50, v = 50;
	    for (int i = 0; i < 256; i++)
		{
		    BUFFER[0] = (char) i;
		    G.drawChars (BUFFER, 0, 1, h, v);
		    h += 20;
		    if (h > 300)
			{
			    v += 20;
			    h = 50;
			}
		}
	}


	public Dimension getPreferredSize ()
	{
	    return new Dimension (400, 400);
	}
	
	public Dimension getMinimumSize ()
	{
	    return new Dimension (400, 400);
	}
    }

    public void MakeFrame ()
    {
	if (UTILITY) j_frame = new JFrame ("UtilityGUI"); // hack
	else if (WIN_TREE) j_frame = new JFrame ("WinningGUI" + BOOK_NAME);
	else if (CLUSTER) j_frame = new JFrame ("ClusterGUI " +BOOK_NAME);
	else j_frame = new JFrame ("LosingGUI "+BOOK_NAME);
	j_frame.addWindowListener
	    (new WindowAdapter()
		{
		    public void windowClosing (WindowEvent win_evt)
		    {
			System.exit (0);
		    }
		}
		);
	InitChessFont (FONT_FILE_NAME, SIZE); // void
	DoGraphics ();
	j_frame.setBackground (Color.lightGray);
	j_frame.pack ();
	j_frame.setSize (850, 675);
	j_frame.setResizable (false);
	j_frame.setVisible (true);
	READY_OK = true;
    }
}
