
#include "TBbuild.h"

#define DEBUG 0

static uint64 RAYS_NW[64], RAYS_SE[64], RAYS_SW[64], RAYS_NE[64];
static uint64 RAYS_N[64], RAYS_S[64], RAYS_W[64], RAYS_E[64];
static char DIREC[64][64];

static void InitRays ()
{ int sq, tr, co, TR, CO;
  for (sq = A1; sq <= H8; sq++)
    { TR = RANK (sq); CO = FILE (sq); RAYS_NE[sq] = 0;
      for (tr = TR, co = CO; tr <= R8 && co <= FH; tr++, co++)
	RAYS_NE[sq] |= SqSet[8 * tr + co]; RAYS_NW[sq] = 0;
      for (tr = TR, co = CO; tr <= R8 && co >= FA; tr++, co--)
	RAYS_NW[sq] |= SqSet[8 * tr + co]; RAYS_SW[sq] = 0;
      for (tr = TR, co = CO; tr >= R1 && co >= FA; tr--, co--)
	RAYS_SW[sq] |= SqSet[8 * tr + co]; RAYS_SE[sq] = 0;
      for (tr = TR, co = CO; tr >= R1 && co <= FH; tr--, co++)
	RAYS_SE[sq] |= SqSet[8 * tr + co]; RAYS_N[sq] = 0;
      for (tr = TR; tr <= R8; tr++) RAYS_N[sq] |= SqSet[8 * tr + CO];
      RAYS_S[sq] = 0;
      for (tr = TR; tr >= R1; tr--) RAYS_S[sq] |= SqSet[8 * tr + CO];
      RAYS_W[sq] = 0;
      for (co = CO; co >= FA; co--) RAYS_W[sq] |= SqSet[8 * TR + co];
      RAYS_E[sq] = 0;
      for (co = CO; co <= FH; co++) RAYS_E[sq] |= SqSet[8 * TR + co];
      RAYS_NE[sq] &= ~SqSet[sq]; RAYS_SW[sq] &= ~SqSet[sq];
      RAYS_N[sq] &= ~SqSet[sq]; RAYS_S[sq] &= ~SqSet[sq];
      RAYS_SE[sq] &= ~SqSet[sq]; RAYS_NW[sq] &= ~SqSet[sq];
      RAYS_E[sq] &= ~SqSet[sq]; RAYS_W[sq] &= ~SqSet[sq];
    }
}

static void DirecInit () /* symmetric */
{int sq, to;
 for (sq=A1;sq<=H8;sq++) for (to=A1;to<=H8;to++)
 {DIREC[sq][to]=(((RANK(to)>RANK(sq)) || (FILE(to)<FILE(sq)))
		 && (to-sq)!=10 && (to-sq)!=-17);
   if ((RANK(to)-RANK (sq))==(FILE(to)-FILE(sq)) && RANK (sq)>FILE (sq))
     DIREC[sq][to] = 0;}}

/*
typedef struct
{uint8 pi[6],sq[6]; boolean wtm,pawn; uint8 n,d0;
 uint64 Blocked,Occupied; uint64 index,reflect;}
type_PiSq;
*/

uint8 TO64_10[10]={A1,B1,C1,D1,B2,C2,D2,C3,D3,D4};
uint8 TO64_32[32]={ A1,B1,C1,D1, A2,B2,C2,D2, A3,B3,C3,D3, A4,B4,C4,D4,
		    A5,B5,C5,D5, A6,B6,C6,D6, A7,B7,C7,D7, A8,B8,C8,D8};
uint8 TO64_24[32]={ A2,B2,C2,D2, A3,B3,C3,D3, A4,B4,C4,D4,
		    A5,B5,C5,D5, A6,B6,C6,D6, A7,B7,C7,D7};

uint32 BIN5[72],BIN4[72],BIN3[72],BIN2[72];

static uint32 get_unrep5(uint32 w) // from index to 6+6+6+6+6 // SLOW, but...
{uint32 a,b,c,d,e; a=4; while (BIN5[a]<=w) a++; a--; w-=BIN5[a];
 b=3; while (BIN4[b]<=w) b++; b--; w-=BIN4[b];
 c=2; while (BIN3[c]<=w) c++; c--; w-=BIN3[c];
 d=1; while (BIN2[d]<=w) d++; d--; w-=BIN2[d]; e=w;
 return (a<<24)|(b<<18)|(c<<12)|(d<<6)|e;}

static uint32 get_unrep5P(uint32 w) // from index to 6+6+6+6+6 // SLOW, but...
{uint32 a,b,c,d,e; a=4; while (BIN5[a]<=w) a++; a--; w-=BIN5[a];
 b=3; while (BIN4[b]<=w) b++; b--; w-=BIN4[b];
 c=2; while (BIN3[c]<=w) c++; c--; w-=BIN3[c];
 d=1; while (BIN2[d]<=w) d++; d--; w-=BIN2[d]; e=w;
 return ((a+8)<<24)|((b+8)<<18)|((c+8)<<12)|((d+8)<<6)|(e+8);}

void FORCE_POS (TableBase * TB, uint64 index, type_PiSq * PiSq)
{int m,i,tb_num; uint64 check,reflect,n=index,q,r,sq;
 PiSq->pawn=TB->pawn_flag; PiSq->wtm=TRUE;
 // NOW_DEBUG=TRUE; printf("FORCEPOS %d\n",index);
 for (i=5;i>0;i--)
 {PiSq->sq[i]=0; PiSq->pi[i]=TB->p[i]; if (!TB->p[i]) continue;
  q=n/TB->m[i]; r=n-q*TB->m[i]; sq=r; n=q;
  if (TB->p[i] && i < 2 && TB->p[i] == TB->p[i+4] && TB->m[i]!=1) // 5 rep
  {if (TB->p[i]==wEnumP || TB->p[i]==bEnumP) m=get_unrep5P(sq);
   else if (TB->p[i]==BlockedPawn) m=get_unrep5P(sq); else m=get_unrep5(sq);
    PiSq->sq[i]=m&077; PiSq->sq[i+1]=(m>>6)&077; PiSq->sq[i+2]=(m>>12)&077;
    PiSq->sq[i+3]=(m>>18)&077; PiSq->sq[i+4]=(m>>24)&077;}
  else if (TB->p[i] && i < 3 && TB->p[i] == TB->p[i+3] && TB->m[i]!=1) // 4 rep
  {if (TB->p[i]==wEnumP || TB->p[i]==bEnumP) m=UNDO_REP4P[sq];
   else if (TB->p[i]==BlockedPawn) m=UNDO_REP4Z[sq]; else m=UNDO_REP4[sq];
    PiSq->sq[i]=m&077; PiSq->sq[i+1]=(m>>6)&077;
    PiSq->sq[i+2]=(m>>12)&077; PiSq->sq[i+3]=(m>>18);}
  else if (TB->p[i] && i < 4 && TB->p[i] == TB->p[i+2] && TB->m[i]!=1) // 3 rep
  {if (TB->p[i]==wEnumP || TB->p[i]==bEnumP) m=UNDO_REP3P[sq];
   else if (TB->p[i]==BlockedPawn) m=UNDO_REP3Z[sq]; else m=UNDO_REP3[sq];
    PiSq->sq[i]=m&077; PiSq->sq[i+1]=(m>>6)&077; PiSq->sq[i+2]=(m>>12);}
  else if (TB->p[i] && i < 5 && TB->p[i] == TB->p[i+1] && TB->m[i]!=1) // 2 rep
  {if (TB->p[i]==wEnumP || TB->p[i]==bEnumP) m=UNDO_REP2P[sq];
   else if (TB->p[i]==BlockedPawn) m=UNDO_REP2Z[sq]; else m=UNDO_REP2[sq];
    PiSq->sq[i]=m&077; PiSq->sq[i+1]=m>>6;}
  else if (TB->m[i]!=1)
  {if (TB->m[i]==48 || TB->m[i]==40) sq+=8; PiSq->sq[i]=sq;}}
 PiSq->pi[0]=TB->p[0]; // leading piece
 if (TB->rep[0]==1)
 {if (TB->pawn_flag)
  {if (PiSq->pi[0]==wEnumP || PiSq->pi[0]==bEnumP || PiSq->pi[0]==BlockedPawn)
      PiSq->sq[0]=TO64_24[n]; else PiSq->sq[0]=TO64_32[n];}
  else PiSq->sq[0]=TO64_10[n];}
 if (TB->rep[0]==2) // GEH // beats me what this code is doing?
 {if (TB->p[0]==wEnumP || TB->p[0]==bEnumP) m=UNDO_REP2P[n];
  else if (TB->p[0]==BlockedPawn) m=UNDO_REP2Z[n];
  else m=UNDO_REP2[n]; PiSq->sq[0]=m&077; PiSq->sq[1]=m>>6;}
 PiSq->Blocked=PiSq->Occupied=0;
 for (i=0;i<6;i++)
   if (PiSq->pi[i]==BlockedPawn) PiSq->Blocked|=(1ULL<<PiSq->sq[i]);
 for (i=0;i<6;i++) if (PiSq->pi[i])
 {PiSq->Occupied|=(1ULL<<PiSq->sq[i]); PiSq->n=i+1;}
 for (i=0;i<6;i++)
  if (PiSq->pi[i]==BlockedPawn) PiSq->Occupied|=(256ULL<<PiSq->sq[i]);
 PiSq->index=-1; PiSq->reflect=-1;
 get_index(PiSq,&tb_num,&check,&reflect);
 PiSq->index=check; PiSq->reflect=reflect;
 if (check!=index && index!=reflect)
 {printf("FORCE_POS input:%lld check:%lld reflect:%lld\n",index,check,reflect);
  for (i=0;TB->p[i];i++) printf("%d ",TB->m[i]); printf("\n");
  DUMP_PISQ(PiSq); raise(SIGTRAP);}}

/********************************/ /********************************/

#define ePERD IsLost
#define aPERD SetLost
#define zPERD UnsetLost

#define IsSet emarco
#define IsMarked aMARCO
#define UnMark nonMARCO
#define NewlyLost ePERD
#define UnmarkLost zPERD

static boolean IsMarked (TableBase * tb, uint64 PositionNumber)
{ return IsSet (tb->MARKED, PositionNumber); }

static void UnMark (TableBase * tb, uint64 PositionNumber)
{ UnSet (tb->MARKED, PositionNumber); }

static boolean IsLost (TableBase * tb, uint64 PositionNumber)
{ return IsSet (tb->LOST, PositionNumber); }

static void SetLost (TableBase * tb, uint64 PositionNumber)
{ Set (tb->LOST, PositionNumber); }

static void UnsetLost (TableBase * tb, uint64 PositionNumber)
{ UnSet (tb->LOST, PositionNumber);}

static int ITERATION_NUMBER = 0;

static void SubtractRemaining(TableBase* tb, uint64 ind)
{ uint8 Value; Value = tb->DATA[ind];
  if (DEBUG) printf("Value is %d %s %lld\n",Value,tb->string,ind);
  if (Value >= FIRST_LOSS)
    { printf ("MAL z:%d %lld (sottRIMA)\n", Value, ind); exit (1); }
  if (Value == 1)
    { SetLost (tb, ind);
      if (0 && ITERATION_NUMBER >= LARGH) // fix for long runs
	{
	  tb->DATA[ind] = PERD_FINE; tb->supp++;
	  // some sort of disk write
	}
      else tb->DATA[ind] = LOST_IN (ITERATION_NUMBER);
    }
  else if (Value <= MAX_MOVE_COUNT) // needs to ignore positions with caps
    tb->DATA[ind] = Value - 1;
}

/********************************/ /********************************/

static void RightIndex(uint64 index, TableBase * LeftTB, TableBase * RightTB)
{  SubtractRemaining (RightTB, index); }

#define HasCapture(x,y) (x[y]>=CAPTURE_WIN && x[y]<=CAPTURE_LOSS)
static void LeftIndex( uint64 ind, TableBase * LeftTB, TableBase * RightTB)
{ if (!IsSet (LeftTB->WON, ind) && !HasCapture(LeftTB->DATA,ind))
    { if (DEBUG) printf("NewWin %lld %s\n",ind,LeftTB->string);
    Set (LeftTB->WON, ind); Set (LeftTB->MARKED, ind); }
  else if (DEBUG)
  {if (IsSet(LeftTB->WON,ind)) printf("IsSet %lld %s\n",ind,LeftTB->string);
   else printf("HasCap %lld %s\n",ind,LeftTB->string);
  }       
 } // ?

/********************************/ /********************************/

#define DIAGONAL 0x8040201008040201
static void FindIndices
(int sq, int to, int i, type_PiSq *PiSq,
 TableBase * LeftTB, TableBase * RightTB, boolean simm,
 void (*INDICE) (uint64, TableBase *, TableBase *))
{uint64 index, reflect; int tb_num;
 if (simm && !DIREC[sq][to]) {if (DEBUG) printf("simm %d %d\n",sq,to); return;}
 PiSq->sq[i]=to; PiSq->wtm=FALSE;
 get_index(PiSq,&tb_num,&index,&reflect);
 PiSq->index=index; PiSq->reflect=reflect;
 if (DEBUG) {printf("retro "); DUMP_PISQ(PiSq);}
 INDICE(index,LeftTB,RightTB);
 PiSq->sq[i]=sq; PiSq->wtm=TRUE;
 if (reflect!=-1 && (reflect!=index || !simm // ok for 3s
		     || !(SqSet[to]&DIAGONAL))) INDICE(reflect,LeftTB,RightTB);
 // maybe also want SqSet[sq]&DIAGONAL check
}

/********************************/ /********************************/

#define ProcessMove(sq, b) \
  (w) ? FindIndices(sq, b, i, PiSq, Tot1, Tot2, simm, RightIndex) : \
        FindIndices(sq, b, i, PiSq, Tot2, Tot1, simm, LeftIndex)
#define PawnMove(sq, b) \
  (w) ? FindIndices(sq, b, i, PiSq, Tot1, Tot2, FALSE, RightIndex) : \
        FindIndices(sq, b, i, PiSq, Tot2, Tot1, FALSE, LeftIndex)

#define LOOP(TARGET, BitFunc, O) \
  { uint64 T = TARGET; \
    while (T) \
      { int b = BitFunc (T); \
	if (SqSet[b] & O) \
	  break; \
	T &= ~SqSet[b]; \
	ProcessMove (sq, b); } }

#define dPERD0 dLOST0
#define dPATT dDRAW
#define DIAGa1h8SOTTO (0x80c0e0f0f8fcfeff)

static boolean doEP (int sq, type_PiSq *ps, int dir, uint8 VALU)
{type_PiSq PiSq[1]; int c,k; uint8 va; CLONE_PISQ(PiSq,ps); PiSq->wtm=FALSE;
 if (!USE_EP_CODE) return FALSE; PiSq->ep=0;
 for (k=0;k<PiSq->n;k++) if (PiSq->sq[k]==sq) break;
 for (c=0;c<PiSq->n;c++) if (PiSq->sq[c]==sq+dir && PiSq->pi[c]==wEnumP)
 {PiSq->sq[c]=sq+8; PiSq->n--;
  PiSq->pi[k]=PiSq->pi[PiSq->n]; PiSq->sq[k]=PiSq->sq[PiSq->n];
  if (!TB_PiSq_score(PiSq,&va)) {DUMP_PISQ(PiSq); raise(SIGTRAP);}
  if (va>=VALU) return TRUE;}  return FALSE;}

static int PROC (TableBase* Tot1, TableBase* Tot2,uint64 index, boolean w)
{ int i, sq, pi; boolean simm; type_PiSq PiSq[1]; uint64 RE_TARGA, Occupied;
  FORCE_POS (Tot1, index, PiSq); // computes index and Double
  if (DEBUG) {printf ("PROC %lld ",index); DUMP_PISQ(PiSq);}
  Occupied = PiSq->Occupied; simm = FALSE;
  if (PiSq->reflect != -1)
    { if (PiSq->index < PiSq->reflect) return 0;
      if (PiSq->index == PiSq->reflect) simm = TRUE; }
  for (i = 0; i < 6 && PiSq->pi[i]; i++)
    { if (PiSq->pi[i] < 7) continue;
      sq = PiSq->sq[i]; pi = PiSq->pi[i];
      if (pi == bEnumP) // should be black pawn now
	{ if (sq <= H6 && !(Occupied & SqSet[sq + 8]))
	    { PawnMove (sq, sq + 8);
	      if (RANK(sq)==R5 && !(Occupied & SqSet[sq + 16]))
		{if (FILE(sq)!=FA && doEP(sq,PiSq,-1,w?dLOST0:dDRAW)) continue;
		 if (FILE(sq)!=FH && doEP(sq,PiSq,1,w?dLOST0:dDRAW)) continue;
		 PawnMove(sq,sq+16);
		} } } 
      if (pi == bEnumN) LOOP (AttN[sq] & ~PiSq->Occupied, BSF, 0);
      if (pi == bEnumB || pi == bEnumQ)
	{ LOOP (RAYS_NW[sq], BSF, Occupied);
	  if (!simm)  LOOP (RAYS_SE[sq], BSR, Occupied);
	  if (!simm || SqSet[sq] & DIAGa1h8SOTTO)
	    { LOOP (RAYS_SW[sq], BSR, Occupied);
	      LOOP (RAYS_NE[sq], BSF, Occupied); }
	}
      if (pi == bEnumK) LOOP (AttK[sq] & ~Occupied, BSF, 0);
      if (pi == bEnumR || pi == bEnumQ)
	{ LOOP (RAYS_N[sq], BSF, Occupied);
	  LOOP (RAYS_W[sq], BSR, Occupied);
	  if (!simm)
	    { LOOP (RAYS_S[sq], BSR, Occupied);
	      LOOP (RAYS_E[sq], BSF, Occupied); } } } 
  return 1;
}

static sint64 ProcessMarked(TableBase * Tot1, TableBase * Tot2)
{ sint64 count = 0; uint64 PositionNumber, u;
  for (PositionNumber = 0; PositionNumber < Tot1->size; PositionNumber++)
    { if (!IsMarked (Tot1, PositionNumber)) continue;
      UnMark (Tot1, PositionNumber);
      count += PROC (Tot1, Tot2, PositionNumber, TRUE);
    }
  return count;
}

static sint64 ProcessRemaining(TableBase * Tot1, TableBase * Tot2)
{ sint64 count = 0; uint64 PositionNumber, u;
  for (PositionNumber = 0; PositionNumber < Tot1->size; PositionNumber++)
    { if (!NewlyLost (Tot1, PositionNumber)) continue;
      UnmarkLost (Tot1, PositionNumber);
      count += PROC (Tot1, Tot2, PositionNumber, FALSE);
    }
  return count;
}

// ep example: wRg1 wPg2 bPh4
// validator
// stats

/********************************/ /********************************/

uint64 loop_marked (TableBase * Tot1, int iter, TableBase * Tot2)
{ uint64 marco = 0; uint64 Clock = GetClock ();
  if (!iter) {InitRays(); DirecInit(); printf("LoopMarked0\n");}
  ITERATION_NUMBER = iter + 1;
  if (ITERATION_NUMBER == LARGH)
    { char FN[1024];
      sprintf (FN, "%sSUPP.%s", Tot2->DIR_NOME, Tot2->string);
      Tot2->Fsupp = fopen (FN, "w");
      printf ("LARGH iterazione %d\n", ITERATION_NUMBER); }
  if (ITERATION_NUMBER >= LARGH)
    { fputc (0xff, Tot2->Fsupp); fputc (0xff, Tot2->Fsupp);
      fputc (0xff, Tot2->Fsupp); fputc (0xff, Tot2->Fsupp);
      fputc (ITERATION_NUMBER & 255, Tot2->Fsupp);
      fputc ((ITERATION_NUMBER >> 8) & 255, Tot2->Fsupp);
      fputc (0xff, Tot2->Fsupp); fputc (0xff, Tot2->Fsupp); }
  printf ("Mossa %d\n", iter);
  marco = ProcessMarked(Tot1,Tot2);
  printf ("MARKED %lld [%.2fs] (iter:%d)\n", marco,
          ((double) (GetClock () - Clock)) / 1000000.0, iter);
  fflush(stdout); return marco;
}

uint64 loop_remaining (TableBase * Tot1, int iter, TableBase * Tot2)
{ uint64 Clock = GetClock (); uint64 rima = 0;
  if (!iter) {InitRays(); DirecInit(); printf("LoopRemaining0\n");}
  rima = ProcessRemaining(Tot1,Tot2);
  printf ("NONE REMAINING %lld [%.2fs]\n", rima,
          ((double) (GetClock () - Clock)) / 1000000.0);
  fflush(stdout);  return rima;
}
