
#include "TBbuild.h"

#define DEBUG 0

void BITBOARD(typePOS *POSITION,type_PiSq *PiSq)
{int i; wBitboardR=wBitboardQ=wBitboardN=wBitboardB=wBitboardP=wBitboardK=0;
 bBitboardR=bBitboardQ=bBitboardN=bBitboardB=bBitboardP=bBitboardK=0;
 POSITION->wtm=PiSq->wtm;
 for (i=0;i<6;i++)
 {if (!PiSq->pi[i]) continue; POSITION->sq[PiSq->sq[i]]=PiSq->pi[i];
  POSITION->bitboard[PiSq->pi[i]]|=(1ULL<<PiSq->sq[i]);}
 wBitboardOcc=wBitboardK|wBitboardQ|wBitboardR|
              wBitboardB|wBitboardN|wBitboardP;
 bBitboardOcc=bBitboardK|bBitboardQ|bBitboardR|
              bBitboardB|bBitboardN|bBitboardP;
 POSITION->OccupiedBW=wBitboardOcc|bBitboardOcc;}

boolean IS_VALID(uint8 *pi,uint8 *v)
{int j,k;
 for (j=0;j<6;j++) for (k=j+1;k<6;k++) if (pi[k] && v[j]==v[k]) return FALSE;
 for (j=0;j<6;j++) for (k=j+1;k<6;k++)
  if (pi[k] && pi[j]==pi[k] && v[j]<v[k]) return FALSE;
 return TRUE;}

static void SetCapture(uint8 *DATA,uint64 ind,uint64 reflect)
{DATA[ind]=CAPTURE_LOSS; if (reflect!=-1) DATA[reflect]=CAPTURE_LOSS;}

static void SetIsDraw(uint8 *DATA,uint64 ind,uint64 reflect)
{DATA[ind]=IS_DRAW; if (reflect!=-1) DATA[reflect]=IS_DRAW;}

static void SetCapDraw(uint8 *DATA,uint64 ind,uint64 reflect)
{DATA[ind]=CAPTURE_DRAW; if (reflect!=-1) DATA[reflect]=CAPTURE_DRAW;}

static void SetRemaining(uint8 *DATA,int n,uint64 ind,uint64 reflect)
{if (DEBUG) printf("SetRemaining %lld %d\n",ind,n);
 DATA[ind]=n; if (reflect!=-1) DATA[reflect]=n;}

void DUMP_PISQ(type_PiSq *PiSq)
{int i; char PI[16]=".PNBRQKZpnbrqk";
  for (i=0;i<6;i++)
    if (PiSq->pi[i]) printf("%d%c%c%c ",i,PI[PiSq->pi[i]],
			    'a'+((PiSq->sq[i])&7),'1'+((PiSq->sq[i])>>3));
  printf("| n:%d wtm:%d pawn:%d %lld %lld ep:%d\n",
	 PiSq->n,PiSq->wtm,PiSq->pawn,PiSq->index,PiSq->reflect,PiSq->ep);
}

#define Bitboard2(x,y) ( ( (uint64) 1) << (x) ) | ( ( (uint64) 1) << (y) )

const uint64 EPtable[8] =
  { Bitboard2 (B4, B4), Bitboard2 (A4, C4),
    Bitboard2 (B4, D4), Bitboard2 (C4, E4),
    Bitboard2 (D4, F4), Bitboard2 (E4, G4),
    Bitboard2 (F4, H4), Bitboard2 (G4, G4) };

#ifdef HAS_POPCNT
static inline int POPCNT (uint64 w)
{
  uint64 x;
  asm ("popcntq %1,%0\n": "=&r" (x):"r" (w));
  return x;
}
#else
static inline int POPCNT (uint64 w)
{
  w = w - ((w >> 1) & 0x5555555555555555ull);
  w = (w & 0x3333333333333333ull) + ((w >> 2) & 0x3333333333333333ull);
  w = (w + (w >> 4)) & 0x0f0f0f0f0f0f0f0full;
  return (w * 0x0101010101010101ull) >> 56;
}
#endif /* HAS_POPCNT */

#define MARK_IT(ptr,x,y) {Set(ptr,x); if (y!=-1) Set(ptr,y);}
void SetupPosition(typePOS *POSITION,type_PiSq *PiSq,
		   uint8 *DATA, uint8 *MARKED, uint8 *WON, uint8 *LOST)
{int tb_num; uint64 index,reflect; uint16 LIST[256]; int i,n; uint8 Value;
 uint32 u,prom=0; uint64 x,ep;
 // 4th rank squares to which an ep pawn can move
 get_index(PiSq,&tb_num,&index,&reflect);
 n=GenMoveList(POSITION,LIST,&ep);
 if (DEBUG) printf("Setup %lld %lld %d %d : ",
		   index,reflect,n,POSITION->sq[TO(LIST[0])]);
 if (DEBUG) {printf("DUMP "); DUMP_PISQ(PiSq);}
#if 0 // International
 if (n==0) {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
            SetRemaining(DATA,IS_WIN,index,reflect); return;}
#else // FICS + International, WON if stalemated has fewer pieces, else DRAW
 if (n==0 && POPCNT(wBitboardOcc)<POPCNT(bBitboardOcc))
 {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
  SetRemaining(DATA,IS_WIN,index,reflect); return;}
 if (n==0) {SetIsDraw(DATA,index,reflect); return;}
#endif
 if (POSITION->sq[TO(LIST[0])]) // no ep
 {SetCapture(DATA,index,reflect); x=bBitboardOcc;
   if (!(x&(x-1))) {MARK_IT(LOST,index,reflect); return;}
  for (i=0;i<n;i++)
  {u=MakePiSqCap(PiSq,LIST[i]);
   if (!TB_PiSq_score(PiSq,&Value))
   {printf("cap %o\n",LIST[i]); DUMP_PISQ(PiSq); raise(SIGTRAP);}
   UndoPiSqCap(PiSq,u);
   if (DISK_SCORE_IS_LOSS(Value))
   {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
    SetRemaining(DATA,IS_WIN,index,reflect);
    if (DEBUG) printf("CaptureWin %o\n",LIST[i]); return;}
   if (DISK_SCORE_IS_DRAW(Value)) SetCapDraw(DATA,index,reflect);}
  if (DATA[index]==CAPTURE_LOSS) MARK_IT(LOST,index,reflect); return;}
 for (i=0;i<n;i++) // prom
 {if (LIST[i]>>12)
  {u=MakePiSqProm(PiSq,LIST[i]); prom++;
   if (!TB_PiSq_score(PiSq,&Value))
   {printf("prom %o\n",LIST[i]); DUMP_PISQ(PiSq); raise(SIGTRAP);}
   if (DEBUG) {printf("PromTry %o %d | ",LIST[i],Value); DUMP_PISQ(PiSq);}
   UndoPiSqProm(PiSq,u);
   if (DISK_SCORE_IS_LOSS(Value))
   {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
    SetRemaining(DATA,IS_WIN,index,reflect); return;
    if (DEBUG) printf("PromWin %o %d\n",LIST[i],Value); return;}
   if (DISK_SCORE_IS_DRAW(Value))
   {if (DEBUG) printf("PromDraw %o %d\n",LIST[i],Value);
    prom--; SetIsDraw(DATA,index,reflect);}}}
 int b1,b2,k,c; uint64 A; type_PiSq PiSq2[1];
 if (USE_EP_CODE && ep) // tricky, very
 {WHILE_LOOP: while (ep)
  {b1=BSF(ep); ep&=(ep-1);
   for (k=0;k<PiSq->n;k++) if (PiSq->sq[k]==b1-16) break;
   A=EPtable[FILE(PiSq->sq[k])]&bBitboardP; uint8 bv=0x01;
   while (A)
   {CLONE_PISQ(PiSq2,PiSq); b2=BSF(A); A&=(A-1); // b2 is from sq
    for (c=0;c<PiSq->n;c++) if (PiSq->sq[c]==b2 && PiSq->pi[c]==bEnumP) break;
    PiSq2->sq[c]=PiSq->sq[k]+8; PiSq2->n--;
    PiSq2->pi[k]=PiSq2->pi[PiSq2->n]; PiSq2->sq[k]=PiSq2->sq[PiSq2->n];
    if (!TB_PiSq_score(PiSq2,&Value)) // is PiSq2->wtm correct here?
    {printf("GEH %d %d %d %d %llx ",b1,b2,k,c,index);
     DUMP_PISQ(PiSq); DUMP_PISQ(PiSq2); raise(SIGTRAP);}
    if (DISK_SCORE_IS_LOSS(Value)) {n--; goto WHILE_LOOP;}
    if (Value>bv) bv=Value;} // no ep capture wins for black
   POSITION->sq[b1]=wEnumP; POSITION->sq[b1-16]=0; POSITION->wtm=FALSE;
   wBitboardOcc^=SqSet[b1]^SqSet[b1-16]; wBitboardP^=SqSet[b1]^SqSet[b1-16];
   POSITION->OccupiedBW=wBitboardOcc|bBitboardOcc;
   uint64 x; int mc=GenMoveList(POSITION,LIST,&x);
   u=(!mc) || (!POSITION->sq[TO(LIST[0])]);
   POSITION->sq[b1]=0; POSITION->sq[b1-16]=wEnumP; POSITION->wtm=TRUE;
   wBitboardOcc^=SqSet[b1]^SqSet[b1-16]; wBitboardP^=SqSet[b1]^SqSet[b1-16];
   POSITION->OccupiedBW=wBitboardOcc|bBitboardOcc;
   if (u) // black has no non-ep captures
   {if (bv==dDRAW) {SetIsDraw(DATA,index,reflect); continue;}
    else {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
          SetRemaining(DATA,IS_WIN,index,reflect); return;}}
   CLONE_PISQ(PiSq2,PiSq);
   for (k=0;k<PiSq->n;k++) if (PiSq->sq[k]==b1-16) break;
   PiSq2->sq[k]=b1; PiSq2->wtm=FALSE; uint8 bv2=bv;
   //   if (DISK_SCORE_IS_DRAW(bv)) bv2=dDRAW;
   //   if (DISK_SCORE_IS_WIN(bv)) bv2=dWIN;
   for (i=0;i<mc;i++) // loop over non-ep caps
   {u=MakePiSqCap(PiSq2,LIST[i]);
    if (!TB_PiSq_score(PiSq2,&Value))
    {printf("cap/ep %o\n",LIST[i]); DUMP_PISQ(PiSq);
     DUMP_PISQ(PiSq2); raise(SIGTRAP);}
    UndoPiSqCap(PiSq2,u); if (Value>bv2) bv2=Value;}
   //   if (DISK_SCORE_IS_LOSS(bv2)) continue; //black wins via non-ep cap
   if (DISK_SCORE_IS_DRAW(bv2)) SetIsDraw(DATA,index,reflect);
   if (DISK_SCORE_IS_WIN(bv2))
   {MARK_IT(WON,index,reflect); MARK_IT(MARKED,index,reflect);
    SetRemaining(DATA,IS_WIN,index,reflect); return;}}}
 if (DATA[index]==CAPTURE_DRAW || DATA[index]==IS_DRAW) return;
 if (n==prom) {SetRemaining(DATA,FIRST_LOSS,index,reflect);
               MARK_IT(LOST,index,reflect); return;}
 SetRemaining(DATA,n-prom,index,reflect);}

char TO64_10[10]; char TO64_32[32];

void setup_tb(TableBase *TB)
{int i,j,sq=0,u; uint8 *pi; typePOS POSITION[1]; type_PiSq PiSq[1];
 uint64 Clock=GetClock(); uint8 w,v[6],S[6],E[6]; // TODO FIX
 printf("setup_tb %s %lld\n",TB->string,TB->size); fflush(stdout);
 TB->DATA=malloc(TB->size); TB->MARKED=malloc(TB->size/8);
 TB->WON=malloc(TB->size/8); TB->LOST=malloc(TB->size/8);
 for (i=0;i<TB->size/8;i++) TB->MARKED[i]=TB->WON[i]=TB->LOST[i]=0;
 POSITION->DYN_ROOT=malloc(MAXIMUM_PLY*sizeof(typeDYNAMIC));
 POSITION->DYN=POSITION->DYN_ROOT+1;
 for (sq=A1;sq<=H8;sq++) POSITION->sq[sq]=0;
 POSITION->DYN->reversible=POSITION->DYN->ep=0;
 pi=TB->p; PiSq->pawn=TB->pawn_flag; PiSq->wtm=TRUE; PiSq->ep=0;
 for (u=0;u<6;u++)
 {S[u]=A1; E[u]=H8; if (pi[u]==0) S[u]=E[u]=-2; if (pi[u]) PiSq->n=u+1;
  if (pi[u]==wEnumP || pi[u]==bEnumP) {S[u]=A2; E[u]=H7;}
  if (pi[u]==BlockedPawn) {S[u]=A2; E[u]=H6;}}
 if (TB->rep[0]==1) // unsure when duple
 {S[0]=0; if (TB->pawn_flag) E[0]=31; else E[0]=9;
  if (pi[0]==wEnumP || pi[0]==bEnumP) {S[0]=4; E[0]=27;}
  if (pi[0]==BlockedPawn) {S[0]=4; E[0]=23;}}
 // printf("%d %d %d %d %d %d\n",pi[0],pi[1],pi[2],pi[3],pi[4],pi[5]);
 // printf("%lld %lld %lld %lld %lld %lld\n",
 //	TB->m[0],TB->m[1],TB->m[2],TB->m[3],TB->m[4],TB->m[5]);
 // printf("%d %d %d %d %d %d\n",S[0],S[1],S[2],S[3],S[4],S[5]);
 // printf("%d %d %d %d %d %d\n",E[0],E[1],E[2],E[3],E[4],E[5]);
 for (i=0;i<TB->size;i++) TB->DATA[i]=UNKNOWN_VALUE;
 for (w=S[0];w<=E[0];w++)
  for (v[1]=S[1];v[1]<=E[1];v[1]++)
   for (v[2]=S[2];v[2]<=E[2];v[2]++)
    for (v[3]=S[3];v[3]<=E[3];v[3]++)
     for (v[4]=S[4];v[4]<=E[4];v[4]++)
      for (v[5]=S[5];v[5]<=E[5];v[5]++)
	{ if (TB->rep[0]==1)
	  {if (!TB->pawn_flag) v[0]=TO64_10[w]; else v[0]=TO64_32[w];}
	  else v[0]=w;
	  if (!IS_VALID(pi,v)) continue;
	  for (j=0;j<6;j++) PiSq->sq[j]=v[j],PiSq->pi[j]=pi[j];
	  for (j=0;j<6;j++) if (pi[j]) POSITION->sq[v[j]]=pi[j]; // BlockedPawn
	  BITBOARD(POSITION,PiSq);
	  SetupPosition(POSITION,PiSq,TB->DATA,TB->MARKED,TB->WON,TB->LOST);
	  for (j=0;j<6;j++) if (pi[j]) POSITION->sq[v[j]]=0; // BlockedPawn
	}
 printf("ok %s [%.2fs]\n",TB->string,((double) (GetClock ()-Clock))/1000000.0);
 fflush(stdout); // free (POSITION->DYN_ROOT); // hmm, should work?
}
