
#include "TBbuild.h"

static char* Name (int j, char* S)
{ if (j == dBROKEN) strcpy (S, "Broken: ");
  if (j == dWIN) strcpy (S, "Win: "); if (j == dDRAW) strcpy (S, "Draw: ");
  if (j >= dLOST0) sprintf (S, "Loss in %d: ", j - dLOST0); return S;}

static void PRINT (char* A, type_PiSq* PiSq, int r1, int r2, char* S)
{
  int k;
  char PI[16][4] = {"", "wP", "wN", "wB", "wR", "wQ", "wK",
                    "", "bP", "bN", "bB", "bR", "bQ", "bK"};
  printf ("%s ",A);
  for (k = 0; PiSq->pi[k] && k < 6 ;k++)
    if (PiSq->pi[k] == BlockedPawn)
      printf("wP%c%c bP%c%c ",
             'a' + FILE (PiSq->sq[k]), '1' + RANK (PiSq->sq[k]),
             'a' + FILE (PiSq->sq[k]), '2' + RANK (PiSq->sq[k]));
    else
      printf("%s%c%c ", PI[PiSq->pi[k]],
             'a' + FILE (PiSq->sq[k]), '1' + RANK (PiSq->sq[k]));
  printf("%d %d %s\n", r1, r2, S);
}


static int try_register(char *s)
{if (RegisterTB(s,"LCTB/2/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/3/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/4/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/5/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/6/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/41/")) {printf("Registered: %s\n",s); return 1;}
 if (RegisterTB(s,"LCTB/32/")) {printf("Registered: %s\n",s); return 1;}
 printf("FAILED to register: %s\n",s); return 0;}

void FORCE_POS (TableBase * TB, uint64 index, type_PiSq * PiSq);
void stats (char *A)
{char B[16],STR[256],STR2[256]; int j,k,n,v;
 TableBase *TB; uint8 y,Y[65536],Z[65536]; uint64 yw,w,c[256];
 strcpy(B,A); n=canonical_name(B);
 v=TB_lookup(B); if (v==-1 || v==0x3fff) if (!try_register(B)) return;
 v=TB_lookup(B); TB=TB_TABLE+(v&0x3fff);
 sprintf(STR,"%s%s%s",TB->DIR_NOME,COMPRESSION_PREFIX+1,TB->string);
 printf("STATS for %s\n",B); for (j=0;j<256;j++) c[j]=0;
 TB->Fdata = fopen (STR, "rb");
 y = dLOST0;
 yw = -1;
 for (j = 0; j < TB->num_indici - 1; j++)
 { int d, w = TB->indici[j+1] - TB->indici[j];
   fread (Z, 1, w, TB->Fdata); d = DecompressBlock (Y, Z, w);
   for (k = 0; k < d; k++)
     { c[Y[k]]++; if (Y[k] > y) { y = Y[k]; yw = j * 0x10000 + k; } } }
 for (j = 0; j < 256; j++)
   if (c[j]) printf ("%s %lld\n", Name (j, STR2), c[j]);
 if (yw != -1)
   { type_PiSq PiSq[1]; FORCE_POS (TB, yw, PiSq);
     PRINT ("maximal loss", PiSq, y - dLOST0, 0, B);}
 fflush(stdout); fclose(TB->Fdata);}

void zugzwang (char *A)
{char B1[16]; int v; uint8 v1,v2; uint64 j; type_PiSq PiSq[1]; TableBase *TB1;
 strcpy(B1,A); canonical_name(B1);
 v=TB_lookup(B1); if (v==-1 || v==0x3fff) if (!try_register(B1)) return;
 v=TB_lookup(B1); TB1=TB_TABLE+(v&0x3fff);
 for (j = 0; j < TB1->size; j++)
 {v1=TB_value(TB1,j); if (v1==dBROKEN) continue;
  FORCE_POS(TB1,j,PiSq); PiSq->wtm=FALSE;
  if (!TB_PiSq_score(PiSq,&v2) || (v2==dBROKEN)) continue;
  if (v1>dLOST0 && v2>dLOST0) PRINT("0:1 1:0",PiSq,v1-dLOST0,v2-dLOST0,B1);
  //  if (v1>dLOST0 && v2==dDRAW) PRINT("DRAW 1:0",PiSq,v1-dLOST0,0,B1);
  //  if (v2>dLOST0 && v1==dDRAW) PRINT("1:0 DRAW",PiSq,0,v2-dLOST0,B1);
  fflush(stdout); }}

#define FLAT_DIR "FLAT"
#define FLAT_PREFIX "FLAT."
void flatten (char *A)
{char B[16],STR[256],STR2[256]; int j,k,n,v; uint8 O[16384];
 TableBase *TB; uint8 y,Y[65536],Z[65536]; uint64 yw,w,c[256];
 strcpy(B,A); n=canonical_name(B);
 v=TB_lookup(B); if (v==-1 || v==0x3fff) if (!try_register(B)) return;
 v=TB_lookup(B); TB=TB_TABLE+(v&0x3fff);
 sprintf(STR,"%s%s%s",TB->DIR_NOME,COMPRESSION_PREFIX+1,TB->string);
 printf("FLATTEN for %s\n",B);
 TB->Fdata = fopen (STR, "rb");
 sprintf(STR,"%s/%d/%s%s",FLAT_DIR,strlen(TB->string),FLAT_PREFIX,TB->string);
 printf("STR: %s %d %s\n",STR,v,TB->string);
 TB->FLAT=fopen(STR,"w");
 for (j = 0; j < TB->num_indici - 1; j++)
 { int d, w = TB->indici[j+1] - TB->indici[j];
   fread (Z, 1, w, TB->Fdata); d = DecompressBlock (Y, Z, w);
   for(k=0;k<16384;k++) O[k]=0;
   for (k = 0; k < d; k++)
   {if (Y[k]>3) Y[k]=3; O[k>>2]|=Y[k]<<(2*(k&3));}
   fwrite(O,1,d>>2,TB->FLAT);}
 fclose(TB->FLAT); fclose(TB->Fdata);}
