
#include "TBbuild.h"

int CPUS=1;

#define DISK_SWAP FALSE
#define doit_func setup_tb

#define DEBUG 0

void CLONE_PISQ(type_PiSq *O,type_PiSq *I) {memcpy(O,I,sizeof(type_PiSq));}

static void FINALIZE(TableBase *TB)
{uint64 u; char NOME_FILE[1024]; FILE* F; uint32 v;
 for (u=0;u<TB->size;u++)
 {if (TB->DATA[u]==IS_WIN || TB->DATA[u]==CAPTURE_WIN || IsMarked(TB->WON,u))
  {TB->DATA[u]=dWIN; continue;}
  if (TB->DATA[u]==BROKEN_VALUE || TB->DATA[u]==UNKNOWN_VALUE)
  {TB->DATA[u]=dBROKEN; continue;}
  if (TB->DATA[u]<MAX_MOVE_COUNT) {TB->DATA[u]=dDRAW; continue;}
  if (TB->DATA[u]==CAPTURE_LOSS) {TB->DATA[u]=dLOST0; continue;}
  if (TB->DATA[u]==CAPTURE_DRAW || TB->DATA[u]==IS_DRAW)
    {TB->DATA[u]=dDRAW; continue;}
  if (TB->DATA[u]>=FIRST_LOSS) TB->DATA[u]-=FIRST_LOSS-dLOST0;}
 // for (u=0;u<TB->size;u++) printf("%d %d\n",u,TB->data[u]);
 // uint64 res; for (u=0;u<TB->size;u++) res+=TB->DATA[u];
 // printf("res is %lld\n",res);
 // int i; for (i=0;i<TB->size;i++) printf("CHK %d %d\n",i,TB->DATA[i]);
 compress_tb(TB);
 sprintf(NOME_FILE,"%s%s%s",TB->DIR_NOME,COMPRESSION_PREFIX,TB->string);
 F=fopen(NOME_FILE,"w");
 fputc (0xca,F); fputc (0x7f,F); fputc (0x0b,F); fputc (0xaa,F);
 fputc(0,F); fputc(0,F); fputc(1,F); fputc(0,F);
 fputc(0,F); fputc(0,F); fputc(0,F); fputc(0,F);
 v=TB->num_indici;
 fputc (v & 255, F); fputc ((v >> 8) & 255, F);
 fputc ((v >> 16) & 255, F); fputc ((v >> 24) & 255, F);
 fwrite (TB->indici, sizeof (uint32), v, F); fclose (F);
 sprintf(NOME_FILE,"%s%s%s",TB->DIR_NOME,COMPRESSION_PREFIX+1,TB->string);
 F=fopen (NOME_FILE,"w"); v=0;
 for(u=0; u < TB->size; u += 0x10000, v++)
   fwrite (TB->DATA + u, 1, TB->indici[v + 1] - TB->indici[v], F); fclose(F);
 // free (TB->indici); TB->indici = NULL; // breaks some C libs
 free(TB->DATA); free(TB->WON); free(TB->LOST); free(TB->MARKED);
 char STRING[16],D[16]; strcpy(STRING,TB->string); strcpy(D,TB->DIR_NOME);
 RemoveTB(TB); RegisterTB(STRING,D);} // printf("HI %s/%s\n",D,STRING);

void SPIT_TB_DATA(TableBase *tb)
{uint64 i,sz=tb->size; type_PiSq PiSq[1];
 for (i=0;i<sz;i++)
 { FORCE_POS(tb,i,PiSq);
   if (IsMarked(tb->WON,i)) printf("RES %d %s ",i,"WIN");
   else printf("RES %d %d ",i,tb->DATA[i]);
   DUMP_PISQ(PiSq); } }


void TB_build_diff(TableBase *TB1,TableBase *TB2)
{int num; TB1->is_uno=TRUE; TB2->is_uno=FALSE; TB1->simm = TB2->simm = FALSE;
 doit_func(TB1); doit_func(TB2); // should be wrapped
 for (num=0;;num++)
 {loop_remaining(TB2,num,TB1); if (!loop_marked(TB1,num,TB2)) break;}
 for (num=0;;num++)
 {loop_remaining(TB1,num,TB2); if (!loop_marked(TB2,num,TB1)) break;}
 if (DEBUG) {SPIT_TB_DATA(TB1); SPIT_TB_DATA(TB2);}
 FINALIZE (TB1); FINALIZE (TB2);}

void TB_build_same(TableBase *TB)
{int num; TB->simm=TRUE; doit_func(TB); // should be wrapped
 for (num=0;;num++)
 {loop_remaining(TB,num,TB); if (!loop_marked(TB,num,TB)) break;} 
 if (DEBUG) {SPIT_TB_DATA(TB);} FINALIZE(TB);}

#define TB_DIR "LCTB"
void doit(char *I)
{char S[32],DN[32]; printf("doit %s\n",I);
 sprintf(DN,"%s/%d/",TB_DIR,strlen(I));
 add_TB(TB_TABLE+NUM_TBS,I,DN); symm(S,I);
 if (strcmp(S,I))
 {add_TB(TB_TABLE+NUM_TBS,S,DN);
  TB_build_diff(TB_TABLE+NUM_TBS-2,TB_TABLE+NUM_TBS-1);}
 else TB_build_same(TB_TABLE+NUM_TBS-1); // sott and registro ?
}

static int TB_is_ok(char *A)
{int j,w=0,b=0;
 for (j=0;j<6 && A[j];j++) if (A[j]>='A' && A[j]<='Y') w++;
 for (j=0;j<6 && A[j];j++) if (A[j]>='a' && A[j]<='y') b++;
 // printf("TB_is_ok %s %d %d %d\n",A,w,b,TB_lookup(A));
 if (!w || !b) return TRUE; return (TB_lookup(A)!=0xffffffff);}

#define RECURSE(x) if (!TB_is_ok(x)) doit_recurse(x)
static void doit_recurse(char *I)
{int i,j,n; char S[32],A[32],C[32]; char W[8]="KQRBN",B[8]="kqrbn";
  printf("doit_recurse %s\n",I);
  // should have some --norecurse option to eliminate recursion
 strcpy(A,I); n=canonical_name(A); strcpy(C,A); for (i=n;i<6;i++) C[i]=0;
 for (i=0;i<n;i++)
 {if (C[i]=='P')
  {for (j=0;j<5;j++) {C[i]=W[j]; RECURSE(C); symm(S,C); RECURSE(S);} C[i]='P';}
  if (C[i]=='p')
  {for (j=0;j<5;j++) {C[i]=B[j]; RECURSE(C); symm(S,C); RECURSE(S);} C[i]='p';}
  if (C[i]=='Z')
  {C[i]='P'; RECURSE(C); symm(S,C); RECURSE(S);
   for (j=0;j<n;j++)
   {char u=C[j]; if (i==j || (u>='A' && u<='Z')) continue;
    C[j]='p'; RECURSE(C); symm(S,C); RECURSE(S); C[j]=u;}
   C[i]='p'; RECURSE(C); symm(S,C); RECURSE(S);
   for (j=0;j<n;j++)
   {char u=C[j]; if (i==j || (u>='a' && u<='z')) continue;
    C[j]='P'; RECURSE(C); symm(S,C); RECURSE(S); C[j]=u;} C[i]='Z';}}
 for (i=0;i<n;i++)
 {C[i]=A[n-1]; C[n-1]=0; RECURSE(C); symm(S,C); RECURSE(S); C[i]=A[i];}
 doit(A);}

void do_args (int n, char **A)
{int j,i,b=0; char C[1024][16];
 for (i=1;i<n;i++)
 {if (!strcmp(A[i],"--cpus")) {CPUS=atoi(A[++i]); continue;}
  if (!strcmp(A[i],"--stats")) {for (j=i+1;j<n;j++) stats(A[j]); return;}
  if (!strcmp(A[i],"--zugzwang")) {for (j=i+1;j<n;j++) zugzwang(A[j]); return;}
  if (!strcmp(A[i],"--flatten")) {for (j=i+1;j<n;j++) flatten(A[j]); return;}
  if (!strcmp(A[i],"--verify"))
  {for (j=i+1;j<n;j++) TB_validate(A[j]); return;}
  if (!strcmp(A[i],"--validate"))
  {for (j=i+1;j<n;j++) TB_validate(A[j]); return;}
  if (!strcmp(A[i],"--explore")) return Explorer();
  strcpy(C[b++],A[i]);}
 for (i=0;i<b;i++) doit_recurse(C[i]);}
