
#include "losing.h"

void tree_build(typePOS *POS,PN_NODE *OLD,char *ml);

static uint32 iTreeMove(PN_NODE *T,uint16 mv,uint32 n)
{uint32 x=T[n].child; if (!n) return 0;
 do {if (T[x].move==mv) return x;} while ((x=T[x].sibling)); return 0;}

static uint32 TreeMove(PN_NODE *T,uint16 mv,uint32 n)
{uint32 r=iTreeMove(T,mv,n); if (r==0) return 0;
 if (T[r].loop || T[r].flags&4) return T[r].trans; return r;}

static void parse_input(typePOS *POS,PN_NODE *OLD)
{char STR[4096]; printf("Ready to parse\n"); fgets(STR,4000,stdin);
 if (!parse_moves(POS,STR+6)) {printf("Failure to parse\n"); return;}
 uint32 n=1; typeDYNAMIC *D; D=POS->DYN_ROOT+1;
 while (D!=POS->DYN && n)
 {D++; if (OLD[n].loop) n=OLD[n].trans; n=TreeMove(OLD,D->mv,n);}
 if (!n) {printf("Failure to align moves\n"); return;}
 tree_build(POS,OLD,STR+6);}

////////////////////////////////////////////////////////////////////////

#define SET_CHILD(A,x) (A[x].data|=(1U<<30))
#define DATA_IS_TRANS(A,x) (((A[x].data&(1U<<31)))==(1U<<31))
#define DATA_HAS_CHILD(A,x)\
  (((A[x].data&(3U<<30)))==(1U<<30) && ((A[x].data&0x3fffffff)!=0x3fffffff))
#define TRANS_AND_SIBLING(A,x) (((A[x].data&(3U<<30)))==(3U<<30))
#define DATA_GET_NODE(A,x) (A[x].data&0x3fffffff)
#define DATA_GET_NODEns(A,x) \
  (((A[x].data&0x3fffffff)!=0x3fffffff) ? A[x].data&0x3fffffff : \
   (((A[x].data&(1U<<30))==(1U<<30)) ? ((x)+1) : 0))
#define NEXT_SIBLING(A,x) ((TRANS_AND_SIBLING(A,x)) ? ((x)+1) : \
			   (DATA_IS_TRANS(A,x) ? 0 : DATA_GET_NODEns(A,x)))

static uint32 WinTreeMove(WIN_NODE *W,uint16 mv,uint32 n)
{uint32 c=n+1; if (!DATA_HAS_CHILD(W,n)) return -1;
  do {if (W[c].move==mv) return DATA_IS_TRANS(W,c)?DATA_GET_NODE(W,c):c;}
  while ((c=NEXT_SIBLING(W,c))); return -1;}

void tree_build_wintree(typePOS *POS,WIN_STRUCT *OLD,char *ml);

static void parse_input_wintree(typePOS *POS,WIN_STRUCT *OLD)
{char STR[4096]; printf("Ready to parse\n"); fgets(STR,4000,stdin);
 if (!parse_moves(POS,STR+6)) {printf("Failure to parse\n"); return;}
 typeDYNAMIC *D; D=POS->DYN_ROOT+1; uint32 u,n=0;
 for (u=0;u<OLD->W[0].move;u++) // needs to handle prolog correctly
 {D++; if (D->mv!=OLD->MOVE_LIST[u]) {printf("Prolog failure\n"); return;}}
 while (D!=POS->DYN && n!=-1) {D++; n=WinTreeMove(OLD->W,D->mv,n);}
 if (n==-1) {printf("Failure to align moves\n"); return;}
 tree_build_wintree(POS,OLD,STR+6);}

////////////////////////////////////////////////////////////////////////

static void LoadNode(FILE *F,PN_NODE *P,uint32 w)
{fread(&(P->good),4,1,F); fread(&(P->bad),4,1,F); fread(&(P->size),4,1,F);
 fread(&P->hash,8,1,F); fread(&(P->trans),4,1,F); fread(&(P->loop),4,1,F);
 fread(&(P->parent),4,1,F); fread(&(P->sibling),4,1,F);
 fread(&(P->child),4,1,F); fread(&(P->move),2,1,F);
 fread(&(P->killer),1,1,F); fread(&(P->flags),1,1,F); P->killer=0;}

static PN_NODE* load_book(char *STR)
{PN_NODE P[1],*T; uint32 u,sz; FILE* F; char A[64]; F=fopen(STR,"r");
 if (!F) {strcpy(A,"BOOKS/"); strcat(A,STR); F=fopen(A,"r");}
 if (!F) {printf("Book %s not found\n",STR); exit(1);}
 LoadNode(F,P,0); sz=P->size; printf("BOOK %s has %d pos\n",STR,sz);
 T=CALLOC(sz+0x100000,sizeof(PN_NODE)); T[0].size=sz;
 for (u=1;u<sz;u++) LoadNode(F,T+u,u); fclose(F);
 for (u=0;u<sz;u++) T[u].killer=0; return T;}

static WIN_STRUCT* load_wintree_book(char *STR)
{WIN_STRUCT *WS; WIN_NODE *W; uint32 s,u,d; uint64 sz; FILE *F; char A[64];
 WS=malloc(sizeof(WIN_STRUCT)); WS->W=malloc(4096); W=WS->W; F=fopen(STR,"rb");
 if (!F) {strcpy(A,"PROOFS/"); strcat(A,STR); F=fopen(A,"rb");}
 if (!F) {printf("File %s not available\n",STR); exit(1);}
 fread(&(W[0].data),4,1,F); fread(&(W[0].move),2,1,F);
 d=W[0].data&0x3fffffff; s=W[0].move; WS->MOVE_LIST=malloc(s*sizeof(uint16));
 for (u=0;u<s;u++) fread(&(WS->MOVE_LIST[u]),2,1,F);
 sz=((uint64) d)*sizeof(WIN_NODE); WS->W=realloc(WS->W,sz+65536);
 for (u=1;u<d;u++)
 {fread(&(WS->W[u].data),4,1,F); fread(&(WS->W[u].move),2,1,F);}
 fclose(F); return WS;}

////////////////////////////////////////////////////////////////////////

static int main_wintree(int c,char **I)
{typePOS POS[1]; WIN_STRUCT *OLD;
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->DYN=POS->DYN_ROOT+1;
 srandom((uint32) Now()); init_position(POS,"startpos");
 printf("TREE BUILDER (WINTREE)\n"); fflush(stdout);
 init_known(FALSE); OLD=load_wintree_book(I[2]);
 parse_input_wintree(POS,OLD); return 0;}

int main(int c,char **I)
{typePOS POS[1]; PN_NODE *OLD; magic_mult_init();
 if (!strcmp(I[1],"--wintree")) return main_wintree(c,I);
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->DYN=POS->DYN_ROOT+1;
 srandom((uint32) Now()); init_position(POS,"startpos");
 printf("TREE BUILDER\n"); fflush(stdout);
 init_known(FALSE); OLD=load_book(I[1]); parse_input(POS,OLD); return 0;}
