
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <dirent.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define boolean uint8
#define uint8 unsigned char
#define uint16 unsigned short int
#define uint32 unsigned int
#define uint64 unsigned long long int
#define TRUE 1
#define FALSE 0

static uint8 hexit(uint8 x) {if (x<='9') return x-'0'; return x-'a'+10;}

static uint8 FRONT[4]={0x83,0x37,0xfb,0x26},BACK[4]={0x29,0xae,0x47,0x08};

static void read_known_file(char *D,char *fn,FILE **F16,int DELETE)
{int j,u; uint64 HASH=0; FILE *F; char A[64],*DATA;
 uint32 bsz,sz; uint16 mv,ML[1024]; if (fn[0]=='.') return;
 if ((fn[0]!='0') || (fn[1]!='x')) return;
 sprintf(A,"%s/%s",D,fn); u=hexit(fn[15]);
 F=fopen(A,"r"); if (!F) {printf("Problem opening %s\n",A); return;}
 for (j=0;j<16;j++) HASH|=((uint64) hexit(fn[17-j]))<<(4*j);
 fwrite(FRONT,1,4,F16[u]); fwrite(&HASH,8,1,F16[u]);
 fread(&sz,4,1,F); fread(&mv,2,1,F); for (j=0;j<mv;j++) fread(&ML[j],2,1,F);
 fwrite(&sz,4,1,F16[u]); fwrite(&mv,2,1,F16[u]);
 for (j=0;j<mv;j++) fwrite(&ML[j],2,1,F16[u]);
 bsz=6*(sz&0x3fffffff)-6; DATA=malloc(bsz);
 fread(DATA,1,bsz,F); fwrite(DATA,1,bsz,F16[u]); fwrite(BACK,1,4,F16[u]);
 free(DATA); fclose(F); if (DELETE) remove(A);}

static void import_known_dir(uint32 w,int DELETE)
{struct dirent *DE; DIR *dir; char S[64],O[64]; struct stat buf;
 FILE *F16[16]; int u; printf("Transferring directory KNOWN/0x%02x\n",w);
 for (u=0;u<16;u++)
 {sprintf(O,"KNOWN/KNOWN0x%x%02x",u,w);
  if (stat(O,&buf)!=-1) {printf("%s already exists\n",O); return;}}
 sprintf(S,"KNOWN/0x%02x",w); dir=opendir(S);
 if (!dir) {printf("Directory %s not found\n",S); return;}
 for (u=0;u<16;u++)
 {sprintf(O,"KNOWN/KNOWN0x%x%02x",u,w); F16[u]=fopen(O,"w");}
 while ((DE=readdir(dir))) read_known_file(S,DE->d_name,F16,DELETE);
 for (u=0;u<16;u++) fclose(F16[u]); closedir(dir); if (DELETE) rmdir(S);}

static void import_known(int DELETE)
{uint32 u; for (u=0;u<0x100;u++) import_known_dir(u,DELETE);}

////////////////////////////////////////////////////////////////////////

static void get_oldbundle_data(char *D,char *fn,FILE *O)
{int j; uint64 HASH=0; uint32 bsz,sz; uint16 mv,ML[1024];
 FILE *F; char *DATA,A[64]; sprintf(A,"%s/%s",D,fn);
 if ((fn[0]!='0') || (fn[1]!='x')) return;
 F=fopen(A,"r"); if (!F) {printf("Problem opening %s\n",A); return;}
 for (j=0;j<16;j++) HASH|=((uint64) hexit(fn[17-j]))<<(4*j);
 fwrite(FRONT,1,4,O); fwrite(&HASH,8,1,O);
 fread(&sz,4,1,F); fread(&mv,2,1,F); for (j=0;j<mv;j++) fread(&ML[j],2,1,F);
 fwrite(&sz,4,1,O); fwrite(&mv,2,1,O); for (j=0;j<mv;j++) fwrite(&ML[j],2,1,O);
 bsz=6*(sz&0x3fffffff)-6; DATA=malloc(bsz); fread(DATA,1,bsz,F);
 fwrite(DATA,1,bsz,O); fwrite(BACK,1,4,O); free(DATA); fclose(F);}

static void oldbundle(int u,char *fn,FILE *F)
{char S[256]; struct dirent *DE; DIR *dir; 
 sprintf(S,"%s/0x%02x",fn,u); dir=opendir(S);
 while ((DE=readdir(dir))) get_oldbundle_data(S,DE->d_name,F); closedir(dir);}

static void do_oldbundle(char *fn)
{uint32 u; FILE *F; F=fopen("KNOWN.bundle","w");
 for (u=0;u<0x100;u++) oldbundle(u,fn,F); fclose(F);}

static void new_bundle(int u,char *fn,FILE *F)
{char S[256]; FILE *I; uint8 D[4]; sprintf(S,"%s/KNOWN0x%03x",fn,u);
 I=fopen(S,"r"); if (!I) {printf("Problem opening %s\n",S); return;}
 while (fread(D,1,1,I)) fwrite(D,1,1,F); fclose(I);}

static void do_bundle(char *fn) // just concat KNOWN files
{uint32 u; FILE *F; F=fopen("KNOWN.bundle","w");
 for (u=0;u<0x1000;u++) new_bundle(u,fn,F); fclose(F);}

////////////////////////////////////////////////////////////////////////

static void do_indexit(uint32 w)
{char O[64],P[64]; FILE *F,*G; uint8 bytes[4]; int u,n,j;
 uint64 num,cur; uint32 sz,bsz; char *DATA; uint16 mv,ML[1024]; uint64 HASH;
 sprintf(P,"KNOWN/KNOWN0x%03x",w);
 F=fopen(P,"r"); if (!F) {printf("%s not found\n",P); return;}
 printf("Indexing %03x\n",w);
 sprintf(O,"KNOWN/iKNOWN0x%03x",w); G=fopen(O,"w");
 while (TRUE)
 {cur=ftell(F); n=fread(bytes,1,4,F); if (!n) break;
  for (u=0;u<4;u++) if (bytes[u]!=FRONT[u])
  {printf("Bad header in %s %lld: %d %x %x\n",P,cur,u,bytes[u],FRONT[u]);
   fclose(F); fclose(G); return;}
  fread(&HASH,8,1,F);
  fread(&sz,4,1,F); fread(&mv,2,1,F); for (j=0;j<mv;j++) fread(&ML[j],2,1,F);
  bsz=6*(sz&0x3fffffff)-6; DATA=malloc(bsz); fread(DATA,1,bsz,F);
  free(DATA); fread(bytes,1,4,F);
  for (u=0;u<4;u++) if (bytes[u]!=BACK[u])
  {printf("Bad footer in %s %ld: %d %x %x\n",P,ftell(F),u,bytes[u],BACK[u]);
   fclose(F); fclose(G); return;}
  num=ftell(F)-cur; fwrite(&HASH,8,1,G); fwrite(&num,8,1,G);} // num is size
 fclose(F); fclose(G);}

static void do_indexing() {int u; for (u=0;u<0x1000;u++) do_indexit(u);}

////////////////////////////////////////////////////////////////////////

static uint8 do_verifyit(uint32 w,boolean VERBOSE)
{char O[64],P[64]; FILE *F,*I; int u,c=0; uint8 OK=1;
 uint64 hash,HASH,sz,run=0; uint8 tmp[4];
 sprintf(P,"KNOWN/KNOWN0x%03x",w);
 F=fopen(P,"r"); if (!F) {printf("%s not found\n",P);}
 sprintf(O,"KNOWN/iKNOWN0x%03x",w);
 I=fopen(O,"r"); if (!I) {printf("%s not found\n",O);} if (!F && !I) return 2;
 if (!F || !I) {if (F) fclose(F); if (I) fclose(I); return 0;}
 while (fread(&HASH,8,1,I))
 {fread(&sz,8,1,I); c++;
  if (VERBOSE)
    printf("Entry %d: HASH %016llx sz %lld start 0x%llx\n",c,HASH,sz,run);
  fseek(F,run,SEEK_SET); fread(tmp,1,4,F);
  for (u=0;u<4;u++) if (FRONT[u]!=tmp[u]) {printf("Bad header\n"); OK=0;}
  fread(&hash,8,1,F); if (HASH!=hash) {printf("Bad hash\n"); OK=0;}
  fseek(F,run+sz-4,SEEK_SET); fread(tmp,1,4,F);
  for (u=0;u<4;u++) if (BACK[u]!=tmp[u]) {printf("Bad footer\n"); OK=0;}
  if (!OK) break; run+=sz;} fclose(F); fclose(I); return OK;}

static void do_repairit(uint32 w);

static void do_verify_all(boolean REPAIR)
{int u,b=0; boolean r; uint32 BAD[0x1000];
 for (u=0;u<0x1000;u++)
 {printf("Verifying 0x%03x ",u); r=do_verifyit(u,FALSE); if (!r) BAD[b++]=u;
  if (r==2) printf("EMPTY\n"); else printf("%s\n",r?"OK":"BAD");}
 if (!b) {printf("Everything is OK!\n"); return;}
 printf("Total of %d corrupted files: ",b);
 for (u=0;u<b;u++) printf("0x%03x ",BAD[u]); printf("\n");
 if (REPAIR) for (u=0;u<b;u++) do_repairit(BAD[u]);}

static void do_verify(int x)
{if (x==-1) do_verify_all(FALSE); else do_verifyit(x,TRUE);}

////////////////////////////////////////////////////////////////////////

static void do_repairit(uint32 w) // same as indexing, but error checking
{char P[64],Q[64],STR[64]; FILE *F,*D,*I; uint64 h,cur=0,skip=0,by;
 uint32 data,sz; uint16 mv; int u,e,c=0; uint8 T[4];
 uint16 *PRO,*MOVES; uint32 *DATA; boolean check;
 printf("Repairing 0x%03x\n",w);
 sprintf(Q,"KNOWN/iKNOWN0x%03x",w); I=fopen(Q,"r");
 sprintf(STR,"KNOWN/iOLDKNOWN0x%03x",w);
 if (I) {printf("Moving index file to %s\n",STR); rename(Q,STR); fclose(I);}
 sprintf(P,"KNOWN/KNOWN0x%03x",w); F=fopen(P,"r");
 sprintf(STR,"KNOWN/OLDKNOWN0x%03x",w);
 if (!F) {printf("%s not found, recovery not possible\n",P); return;}
 if (F) {printf("Moving data file to %s\n",STR); fclose(F); rename(P,STR);}
 F=fopen(STR,"r"); D=fopen(P,"w"); I=fopen(Q,"w");
 if (!F || !D || !I) {printf("Error opening files to write\n"); return;}
 while (TRUE)
 {fseek(F,cur+skip,SEEK_SET); e=fread(T,1,4,F); if (e<4) break;
  check=TRUE; for (u=0;u<4;u++) if (FRONT[u]!=T[u]) check=FALSE;
  if (!check) {skip++; continue;} fread(&h,8,1,F);
  printf("Entry %d: At 0x%llx (skip %lld) HASH 0x%016llx\n",
	 ++c,cur+skip,skip,h);
  fread(&data,4,1,F); fread(&mv,2,1,F); sz=data&0x3fffffff; by=6*sz+2*mv+16;
  printf("Claims %d nodes and %d-move prolog (%lld bytes)\n",sz,mv,by);
  DATA=malloc(sizeof(uint32)*sz); MOVES=malloc(sizeof(uint16)*sz);
  PRO=malloc(sizeof(uint16)*mv); for (u=0;u<mv;u++) fread(&PRO[u],2,1,F);
  for (u=1;u<sz;u++) {fread(&DATA[u],4,1,F); fread(&MOVES[u],2,1,F);}
  fread(T,1,4,F); check=TRUE; for (u=0;u<4;u++) if (BACK[u]!=T[u]) check=FALSE;
  if (!check) {printf("Footer not acceptable\n"); skip++;
               free(DATA); free(MOVES); free(PRO); continue;}
  printf("Footer matches, writing record\n");
  fwrite(FRONT,1,4,D); fwrite(&h,8,1,D); fwrite(&data,4,1,D);
  fwrite(&mv,2,1,D); for (u=0;u<mv;u++) fwrite(&PRO[u],2,1,D);
  for (u=1;u<sz;u++) {fwrite(&DATA[u],4,1,D); fwrite(&MOVES[u],2,1,D);}
  fwrite(BACK,1,4,D); fwrite(&h,8,1,I); fwrite(&by,8,1,I); cur+=skip+by;
  skip=0; free(PRO); free(DATA); free(MOVES);} fclose(D); fclose(I);
 if (1) // Klaas says it is preferable to delete these
 {printf("Removing the iOLDKNOWN and OLDKNOWN files\n");
  sprintf(STR,"KNOWN/iOLDKNOWN0x%03x",w); remove(STR);
  sprintf(STR,"KNOWN/OLDKNOWN0x%03x",w); remove(STR);}}

////////////////////////////////////////////////////////////////////////

typedef struct {uint64 hash; uint64 offset;} tKNOWN;
static tKNOWN *KNOWN_TABLE;
static uint64 KNOWN_MASK;
static uint64 KNOWN_OFFSET[0x1000];
static uint64 known_num;

static uint64 known_find(uint64 Z)
{uint64 k=Z&KNOWN_MASK; uint64 z;
 while ((z=KNOWN_TABLE[k].hash))
 {if (z==Z) return KNOWN_TABLE[k].offset; k++; if (k>KNOWN_MASK) k=0;}
 return -1;}

static void known_add_os(uint64 Z,uint64 os)
{uint64 k=Z&KNOWN_MASK; uint64 z;
 while ((z=KNOWN_TABLE[k].hash))
 {if (z==Z) return; k++; if (k>KNOWN_MASK) k=0;}
 KNOWN_TABLE[k].hash=Z; KNOWN_TABLE[k].offset=os;}

static void rebuild_known()
{int u; uint64 sz; tKNOWN *OLD_KNOWN;
 sz=KNOWN_MASK+1; KNOWN_MASK=2*KNOWN_MASK+1; known_num=0;
 OLD_KNOWN=KNOWN_TABLE; KNOWN_TABLE=malloc(sizeof(tKNOWN)*(sz*2));
 for (u=0;u<2*sz;u++) KNOWN_TABLE[u].hash=KNOWN_TABLE[u].offset=0;
 for (u=0;u<sz;u++)
   if (OLD_KNOWN[u].hash) known_add_os(OLD_KNOWN[u].hash,OLD_KNOWN[u].offset);
 free(OLD_KNOWN);}

static void known_add(uint64 Z,uint64 sz,boolean STARTUP)
{uint64 k=Z&KNOWN_MASK; uint64 z;
 while ((z=KNOWN_TABLE[k].hash)) // inc OFFSET when HASH is found on STARTUP
 {if (z==Z) {if (STARTUP) KNOWN_OFFSET[Z&0xfff]+=sz; return;}
  k++; if (k>KNOWN_MASK) k=0;}
 KNOWN_TABLE[k].hash=Z; KNOWN_TABLE[k].offset=KNOWN_OFFSET[Z&0xfff];
 KNOWN_OFFSET[Z&0xfff]+=sz;
 known_num++; if (known_num*2>KNOWN_MASK) rebuild_known();}

static void load_known_index(int u)
{char O[64]; FILE *F; uint64 hash,sz;
 sprintf(O,"KNOWN/iKNOWN0x%03x",u); F=fopen(O,"r"); if (!F) return;
 while (fread(&hash,8,1,F)) {fread(&sz,8,1,F); known_add(hash,sz,TRUE);}
 fclose(F);}

static void load_known_indices()
{int i; for (i=0;i<0x1000;i++) load_known_index(i);}

static void init_known(boolean WRITEABLE)
{int i,u; uint64 sz; known_num=0; for (i=0;i<0x1000;i++) KNOWN_OFFSET[i]=0;
 KNOWN_MASK=0xfffff; sz=0x100000; KNOWN_TABLE=malloc(sizeof(tKNOWN)*sz);
 for (u=0;u<sz;u++) KNOWN_TABLE[u].hash=KNOWN_TABLE[u].offset=0;
 load_known_indices(); if (!WRITEABLE) return;
 FILE *F; F=fopen("KNOWN.lock","r");
 if (F) {printf("KNOWN.lock!\n"); fflush(stdout); exit(1);}
 F=fopen("KNOWN.lock","w"); fprintf(F,"PID is %d\n",getpid()); fclose(F);}

static void do_extract(char *fn)
{FILE *I,*O,*F; uint32 u; uint8 A[64],*DATA,tmp[4]; uint32 sz,bsz;
 uint64 by=0,h,HASH,os; char S[64]; uint16 mv,ML[1024]; uint32 data,exc=0;
 I=fopen(fn,"r"); if (!I) {printf("Could not open %s\n",fn); return;}
 init_known(FALSE);
 O=fopen("KNOWN.extract","w"); if (!O) {printf("Error w/extract\n"); return;}
 while (TRUE)
 {u=fread(A,1,12,I); if (!u) break; fread(&HASH,8,1,I); fread(A,1,24,I);
  os=known_find(HASH); if (os==-1) continue;
  printf("Extracting 0x%016llx\n",HASH); exc++;
  sprintf(S,"KNOWN/KNOWN0x%03llx",HASH&0xfff);
  F=fopen(S,"r"); if (!F) {printf("Failure to open %s\n",S); return;}
  fseek(F,os,SEEK_SET); fread(tmp,1,4,F);
  for (u=0;u<4;u++) if (FRONT[u]!=tmp[u])
  {printf("BAD header %016llx %lld\n",HASH,os); fclose(F); return;}
  fread(&h,8,1,F); if (h!=HASH) {printf("Bad hash\n"); fclose(F); return;}
  fread(&data,4,1,F); fread(&mv,2,1,F);
  for (u=0;u<mv;u++) fread(&ML[u],2,1,F); sz=data&0x3fffffff;
  bsz=6*(sz-1); DATA=malloc(bsz); fread(DATA,1,bsz,F); fread(tmp,1,4,F);
  for (u=0;u<4;u++) if (BACK[u]!=tmp[u])
  {printf("BAD footer %016llx %lld\n",HASH,os); free(DATA); fclose(F); return;}
  fwrite(FRONT,1,4,O); fwrite(&HASH,8,1,O); fwrite(&data,4,1,O);
  fwrite(&mv,2,1,O); for (u=0;u<mv;u++) fwrite(&ML[u],2,1,O); by+=bsz+22+2*mv;
  fwrite(DATA,1,bsz,O); fwrite(BACK,1,4,O); free(DATA); fclose(F);}
 printf("Extracted %d records and %lld bytes\n",exc,by); fclose(I); fclose(O);}

static void do_merge(char *fn)
{FILE *I,*D; uint64 Z,skip=0,cur=0,nb,bc; char O[64];
 uint32 u,data; uint16 mv; uint8 tmp[4],*DATA; boolean ck;
 I=fopen(fn,"r"); if (!I) {printf("Could not open %s\n",fn); return;}
 init_known(TRUE);
 while (TRUE)
 {fseek(I,cur+skip,SEEK_SET); if (!fread(tmp,1,4,I)) break;
  ck=TRUE; for (u=0;u<4;u++) if (FRONT[u]!=tmp[u]) ck=FALSE;
  if (!ck) {printf("Bad header %lld\n",cur+skip); skip++; continue;}
  fread(&Z,8,1,I); fread(&data,4,1,I); fread(&mv,2,1,I);
  nb=6*(data&0x3fffffff)+2*mv; fseek(I,cur+skip+12,SEEK_SET);
  DATA=malloc(nb); fread(DATA,1,nb,I); fread(tmp,1,4,I);
  ck=TRUE; for (u=0;u<4;u++) if (BACK[u]!=tmp[u]) ck=FALSE; bc=nb+16;
  if (!ck) {printf("Bad footer %lld\n",cur+skip); free(DATA);skip++; continue;}
  if (known_find(Z)!=-1) {printf("0x%016llx known\n",Z); free(DATA); goto END;}
  printf("Merging 0x%016llx\n",Z); sprintf(O,"KNOWN/KNOWN0x%03llx",Z&0xfff);
  D=fopen(O,"a"); if (!D) {printf("Error opening %s\n",O); return;}
  fwrite(FRONT,1,4,D); fwrite(&Z,8,1,D);
  fwrite(DATA,1,nb,D); fwrite(BACK,1,4,D); free(DATA); fclose(D);
  known_add(Z,bc,FALSE); sprintf(O,"KNOWN/iKNOWN0x%03llx",Z&0xfff);
  D=fopen(O,"a"); if (!D) {printf("Error opening %s\n",O); return;}
  fwrite(&Z,8,1,D); fwrite(&bc,8,1,D); fclose(D); END: cur+=skip+bc; skip=0;}
 fclose(I); remove("KNOWN.lock");}

////////////////////////////////////////////////////////////////////////

static void do_size(uint32 w,uint64 *rc,uint64 *bc)
{char O[64]; FILE *I; uint64 HASH,sz; *rc=0; *bc=0;
 sprintf(O,"KNOWN/iKNOWN0x%03x",w);
 I=fopen(O,"r"); if (!I) {printf("%s not found\n",O); return;}
 while (fread(&HASH,8,1,I)) {fread(&sz,8,1,I); *bc+=sz; *rc+=1;}
 fclose(I); printf("0x%03x has %lld records (%lld bytes)\n",w,*rc,*bc);}

static void do_sizes()
{uint32 u; uint64 RC=0,BC=0,rc,bc;
 for (u=0;u<0x1000;u++) {do_size(u,&rc,&bc); RC+=rc; BC+=bc;}
 printf("Total of %lld records and %lldMB (%lld bytes)\n",RC,BC>>20,BC);}

////////////////////////////////////////////////////////////////////////

int main(int argc,char **argv)
{if (!strcmp(argv[1],"reindex")) do_indexing();
 if (!strcmp(argv[1],"oldbundle")) do_oldbundle(argv[2]);
 if (!strcmp(argv[1],"bundle")) do_bundle(argv[2]);
 if (!strcmp(argv[1],"extract")) do_extract(argv[2]);
 if (!strcmp(argv[1],"merge")) do_merge(argv[2]);
 if (!strcmp(argv[1],"import")) {import_known(FALSE); do_indexing();}
 if (!strcmp(argv[1],"importdelete")) {import_known(TRUE); do_indexing();}
 if (!strcmp(argv[1],"sizes")) do_sizes();
 if (!strcmp(argv[1],"verify")) do_verify(argc>2?strtoul(argv[2],NULL,16):-1);
 if (!strcmp(argv[1],"repair")) do_repairit(strtoul(argv[2],NULL,16));
 // could have this take (argc-2,argv+2) as an argument, and strtoul them all
 if (!strcmp(argv[1],"repairall")) do_verify_all(TRUE);
 // if (!strcmp(argv[1],"verifyfull")) do_verify_full();
 return 0;
}
