
#include "losing.h"

static uint32 NEXT_PAGE; static uint32 *CHILD_LIST;

static void new_child(uint32 p,uint32 c)
{uint32 ptr=16*p,u,v;
 while (TRUE)
 {for (u=ptr,v=0;v<15;u++,v++) if (!CHILD_LIST[u]) {CHILD_LIST[u]=c; return;}
  if (!CHILD_LIST[u])
  {CHILD_LIST[u]=NEXT_PAGE; CHILD_LIST[16*NEXT_PAGE]=c; NEXT_PAGE++; return;}
  ptr=16*CHILD_LIST[u];}}

static void do_child(PN_NODE *TREE,uint32 p)
{uint32 ptr=16*p,s; uint32 LIST[256],WHICH[256]; int u,v,w=0,t;
 if (0) printf("Finding child for %d %d %d\n",p,TREE[p].good,TREE[p].bad);
 while (TRUE)
 {for (u=ptr,v=0;v<15 && CHILD_LIST[u];u++,v++) LIST[w++]=CHILD_LIST[u];
  if (v<15 || !CHILD_LIST[u]) break; ptr=16*CHILD_LIST[u];}
 for (u=0;u<w;u++) WHICH[u]=0;
 for (u=0;u<w;u++)
 {s=TREE[LIST[u]].sibling; if (!s) continue;
  for (t=0;t<w;t++) if (LIST[t]==s) WHICH[t]=1;}
 for (u=0;u<w;u++) if (!WHICH[u])
 {if (0) printf("Found %d for %d\n",LIST[u],p); TREE[p].child=LIST[u];}}

static void repair_children(PN_NODE *TREE)
{uint32 sz=TREE[0].size,u,num=16*(sz+0x100000); NEXT_PAGE=sz;
 CHILD_LIST=malloc(num*sizeof(uint32)); for (u=0;u<num;u++) CHILD_LIST[u]=0;
 for (u=2;u<sz;u++) new_child(TREE[u].parent,u);
 printf("NEXT_PAGE %d\n",NEXT_PAGE);
 for (u=2;u<sz;u++)
  if (!TREE[TREE[u].parent].child) do_child(TREE,TREE[u].parent);
 printf("Repaired children\n"); free(CHILD_LIST);}

////////////////////////////////////////////////////////////////////////

static uint32 *TRANS_LIST;

static void new_trans(uint32 p,uint32 c)
{uint32 ptr=16*p,u,v;
 while (TRUE)
 {for (u=ptr,v=0;v<15;u++,v++) if (!TRANS_LIST[u]) {TRANS_LIST[u]=c; return;}
  if (!TRANS_LIST[u])
  {TRANS_LIST[u]=NEXT_PAGE; TRANS_LIST[16*NEXT_PAGE]=c; NEXT_PAGE++; return;}
  ptr=16*TRANS_LIST[u];}}

static void make_loop(PN_NODE *T,uint32 n)
{uint32 ptr=16*n,last=n,u,v;
 if (T[n].loop) printf("Loop? %d %d %d %d\n",n,T[n].loop,T[n].good,T[n].bad);
 while (TRUE)
 {for (u=ptr,v=0;v<15 && TRANS_LIST[u];u++,v++)
  {T[last].loop=TRANS_LIST[u]; last=TRANS_LIST[u];}
  if (v<15 || !TRANS_LIST[u]) break; ptr=16*TRANS_LIST[u];} T[last].loop=n;}

// should do this by hash ?
static void repair_loops(PN_NODE *T)
{uint32 u,k,sz=T[0].size,num=16*(sz+0x100000); NEXT_PAGE=sz;
 TRANS_LIST=malloc(num*sizeof(uint32)); for (u=0;u<num;u++) TRANS_LIST[u]=0;
 for (k=2;k<sz;k++) if (!T[k].loop && T[k].trans!=k && T[k].flags&4)
  new_trans(T[k].trans,k);
 printf("NEXT PAGE %d\n",NEXT_PAGE);
 for (k=2;k<sz;k++) if (!T[k].loop && T[k].trans!=k && T[k].flags&4)
  make_loop(T,T[k].trans); printf("Repaired loops\n"); free(TRANS_LIST);}

static void forward_trans(PN_NODE *T)
{uint32 n,u,sz=T[0].size;
 for (u=2;u<sz;u++)
 {n=T[u].trans; while (n!=T[n].trans) n=T[n].trans; T[u].trans=n;
  if (T[u].hash!=T[n].hash) printf("TRANS ERROR %d %d\n",n,u);}}

////////////////////////////////////////////////////////////////////////

static HASH *BOOK_HASH; static uint32 BOOK_HASH_MASK;
static HASH *ALL_HASH; static uint32 ALL_HASH_MASK;
static int compare(const void *x,const void *y)
{uint16 a=*((uint16*) x); uint16 b=*((uint16*) y);
  if (a>b) return 1; if (a<b) return -1; return 0;}

static uint32 NewBookHash(HASH *BH,uint32 BHM,uint64 Z,uint32 n)
{uint32 k=Z&BHM; uint64 u; if (!k) k++;
 while ((u=BH[k].key)) {if (u==Z) return BH[k].node; k++; if (k==(BHM+1)) k=1;}
  BH[k].key=Z; BH[k].node=n; return 0;}

static boolean white_wins(typePOS *POS,PN_NODE *T,uint32 n)
{if (POS->wtm && !T[n].bad) return TRUE;
 if (!POS->wtm && !T[n].good) return TRUE; return FALSE;}

static void new_node(typePOS *POS,uint16 mv,PN_NODE *T1,int n1,
		     PN_NODE *T2,int n2,PN_NODE *MT,int par)
{uint32 g,b,c,t,n=MT[0].size++; uint64 Z=POS->DYN->HASH;
 if (n1 && T1[n1].loop) n1=T1[n1].trans;
 if (n2 && T2[n2].loop) n2=T2[n2].trans; MT[n].good=1; MT[n].bad=1;
 if (n1 && !T1[n1].child && n2 && !T2[n2].child)
 {if (!white_wins(POS,T1,n1)) {MT[n].good=T1[n1].good; MT[n].bad=T1[n1].bad;}
  if (!white_wins(POS,T2,n2)) {MT[n].good=T2[n2].good; MT[n].bad=T2[n2].bad;}}
 if (n1 && !T1[n1].child && !white_wins(POS,T1,n1) && !n2)
 {MT[n].good=T1[n1].good; MT[n].bad=T1[n1].bad;}
 if (n2 && !T2[n2].child && !white_wins(POS,T2,n2) && !n1)
 {MT[n].good=T2[n2].good; MT[n].bad=T2[n2].bad;}
 if (known_find(Z)!=-1)
 {if (POS->wtm) {MT[n].good=MY_INFoo; MT[n].bad=0;}
  else {MT[n].bad=MY_INFoo; MT[n].good=0;}}
 MT[n].hash=Z; MT[n].parent=par; MT[n].sibling=MT[n].child=0;
 MT[n].move=mv; MT[n].size=MT[n].killer=0; MT[n].flags=POS->wtm?16:0;
 MT[n].trans=n; MT[n].loop=0; c=MT[par].child;
 if (!c) MT[par].child=n;
 else {while (MT[c].sibling) c=MT[c].sibling; MT[c].sibling=n;}
 if (POS->DYN->rev==0 && (t=NewBookHash(BOOK_HASH,BOOK_HASH_MASK,Z,n)))
 {MT[n].trans=t; MT[n].good=MT[t].good; MT[n].bad=MT[t].bad;
  MT[n].loop=MT[t].loop?MT[t].loop:t; MT[t].loop=n;}
 g=MT[n].good; b=MT[n].bad; if (b && g) MT[n].rat=((float) g)/((float) b);
 if (b==0) MT[n].rat=FLOAT_INF; if (g==0) MT[n].rat=0.0;}

static void merge_trees
(typePOS *POS,PN_NODE *T1,int n1,PN_NODE *T2,int n2,PN_NODE *MT,int mn)
{int mc=0; uint32 c1,c2; uint16 mv,ML[512]; int w,y=1;
 if (known_find(POS->DYN->HASH)!=-1) return;
 if (n1 && T1[n1].loop) n1=T1[n1].trans; // loops have been repaired
 if (n2 && T2[n2].loop) n2=T2[n2].trans;
 if (T1[n1].size && T2[n2].size) return; // already done
 if (n1) T1[n1].size=1; if (n2) T2[n2].size=1;
 c1=T1[n1].child; c2=T2[n2].child;
 if (c1) do {ML[mc++]=T1[c1].move;} while ((c1=T1[c1].sibling));
 if (c2) do {ML[mc++]=T2[c2].move;} while ((c2=T2[c2].sibling));
 ML[mc]=0; qsort(ML,mc,sizeof(uint16),compare);
 for (w=1;ML[w];w++) if (ML[w]!=ML[w-1]) ML[y++]=ML[w]; ML[y]=0; w=0;
 while ((mv=ML[w++]))
 {MakeMoveCheck(POS,mv,FALSE); c1=T1[n1].child; c2=T2[n2].child;
  if (c1) do {if (T1[c1].move==mv) break;} while ((c1=T1[c1].sibling));
  if (c2) do {if (T2[c2].move==mv) break;} while ((c2=T2[c2].sibling));
  new_node(POS,mv,T1,c1,T2,c2,MT,mn);
  merge_trees(POS,T1,c1,T2,c2,MT,MT[0].size-1); UnmakeMove(POS,mv,TRUE);}}

////////////////////////////////////////////////////////////////////////

#define TEMPO (1.0)
#define TEMPO2 (TEMPO*TEMPO)
static boolean node_ratio(PN_NODE *T,uint32 n)
{float r,x=T[n].rat; uint32 c;
 c=T[n].child; if (!c) return FALSE; r=T[c].rat;
 if (x==0.0 || x==FLOAT_INF) return FALSE;
 while ((c=T[c].sibling)) r=MIN(r,T[c].rat);
 if (r==FLOAT_INF) T[n].rat=0.0;
 else if (r==0.0) T[n].rat=FLOAT_INF; else T[n].rat=TEMPO2/r;
 return (x!=T[n].rat);}

static void ratio_backtrack(PN_NODE *T,uint32 n)
{uint32 k,w; if (!n) return; w=T[n].loop?T[n].trans:n;
 if (node_ratio(T,w)) ratio_backtrack(T,T[w].parent);
 k=T[w].loop; if (!k) return;
 while (k!=w && k) // checking k not really necessary here (but is below)
 {float r=T[k].rat; T[k].rat=T[w].rat;
  if (r!=T[w].rat) ratio_backtrack(T,T[k].parent); k=T[k].loop;}}

typedef struct {uint32 n,good,bad;} SORTER;
static int sort_compare(const void *x, const void *y) // increasing good
{SORTER A=*((SORTER*) x); SORTER B=*((SORTER*) y);
  if (A.good<B.good) return -1; if (A.good>B.good) return 1;
  if (A.bad>B.bad) return -1; if (A.bad<B.bad) return 1; return 0;}

static void sort_the_children(PN_NODE *T,uint32 n)
{SORTER S[256]; int i,u=0; uint32 c=T[n].child;
 S[u].bad=T[c].bad; S[u].good=T[c].good; S[u++].n=c;
 while (T[c].sibling)
 {c=T[c].sibling; S[u].bad=T[c].bad; S[u].good=T[c].good; S[u++].n=c;}
 qsort(S,u,sizeof(SORTER),sort_compare); c=S[0].n; T[n].child=S[0].n;
 for (i=1;i<u;i++) {T[c].sibling=S[i].n; c=S[i].n;} T[c].sibling=0;}

#define LOSS_TWIST 0x913bb468de01037fULL
#define WIN_TWIST 0xc066034f796185ebULL

static void install_result(uint64 Z,uint32 n)
{uint32 k=Z&BOOK_HASH_MASK; uint64 u; if (!k) k++;
 while ((u=BOOK_HASH[k].key))
 {if (u==Z) return; k++; if (k==(BOOK_HASH_MASK+1)) k=1;}
  BOOK_HASH[k].key=Z; BOOK_HASH[k].node=n;}

static uint32 is_known_result(uint64 Z)
{uint32 k=Z&BOOK_HASH_MASK; uint64 u; if (!k) k++;
 while ((u=BOOK_HASH[k].key))
 {if (u==Z) return BOOK_HASH[k].node; k++; if (k==(BOOK_HASH_MASK+1)) k=1;}
 return FALSE;}

static void back_step(PN_NODE *T,uint32 n);
static void win_installer(PN_NODE *T,uint32 n)
{uint32 u,k; uint64 Z,z; Z=T[n].hash; install_result(Z^WIN_TWIST,n);
 T[n].rat=FLOAT_INF; ratio_backtrack(T,T[n].parent);
 T[n].loop=0; T[n].trans=n; T[n].bad=0; T[n].good=MY_INFoo; k=Z&ALL_HASH_MASK;
 while ((z=ALL_HASH[k].key))
 {u=ALL_HASH[k].node; k++; if (k==(ALL_HASH_MASK+1)) k=0;
  if ((z==Z) && u!=n)
  {if (!T[u].good) continue; T[u].bad=0; T[u].good=MY_INFoo;
   T[u].flags|=4; T[u].trans=n; T[u].loop=0; T[u].child=0; T[u].rat=FLOAT_INF;
   back_step(T,T[u].parent); ratio_backtrack(T,T[u].parent);}}}

static void loss_installer(PN_NODE *T,uint32 n)
{uint32 u,k; uint64 Z,z; Z=T[n].hash; install_result(Z^LOSS_TWIST,n);
 T[n].rat=0.0; ratio_backtrack(T,T[n].parent);
 T[n].loop=0; T[n].trans=n; T[n].good=0; T[n].bad=MY_INFoo; k=Z&ALL_HASH_MASK;
 while ((z=ALL_HASH[k].key))
 {u=ALL_HASH[k].node; k++; if (k==(ALL_HASH_MASK+1)) k=0;
  if ((z==Z) && u!=n)
  {if (!T[u].bad) continue; T[u].good=0; T[u].bad=MY_INFoo;
   T[u].flags|=4; T[u].trans=n; T[u].loop=0; T[u].child=0; T[u].rat=0.0;
   back_step(T,T[u].parent); ratio_backtrack(T,T[u].parent);}}}

static boolean node_update(PN_NODE *T,uint32 n)
{uint32 c,v,w=T[n].good,l=T[n].bad; if (!T[n].child) return TRUE;
 sort_the_children(T,n); if (!w || !l) return FALSE;
 c=T[n].child; v=T[c].bad; T[n].bad=T[c].good;
 while (T[c].sibling) {c=T[c].sibling; v+=T[c].bad;if (v>MY_INFoo) v=MY_INFoo;}
 if (w && !v && !(T[n].flags&16) &&
     !is_known_result(T[n].hash^LOSS_TWIST)) loss_installer(T,n);
 if (l && !T[n].bad && (T[n].flags&16) &&
     !is_known_result(T[n].hash^WIN_TWIST)) win_installer(T,n);
 T[n].good=v; if (v==w && l==T[n].bad) return FALSE; return TRUE;}

static void back_step(PN_NODE *T,uint32 n)
{if (!n) return; n=T[n].loop?T[n].trans:n;
 if (node_update(T,n)) back_step(T,T[n].parent);
 uint32 k=T[n].loop; if (!k) return;
 while (k!=n && k)
 {uint32 g=T[k].good,b=T[k].bad; T[k].good=T[n].good; T[k].bad=T[n].bad;
  if (g!=T[n].good || b!=T[n].bad) back_step(T,T[k].parent); k=T[k].loop;}}

static void backtrack_info(PN_NODE *T)
{uint32 u,n;
 for (u=1;u<T[0].size;u++)
 {if (!(T[u].flags&4)) n=T[u].trans; else n=u;
  if (!(T[n].flags&4) && !T[n].child)
  {if ((T[n].flags&16) && !T[n].bad) win_installer(T,n);
   if (!(T[n].flags&16) && !T[n].good) loss_installer(T,n);
   back_step(T,T[n].parent); ratio_backtrack(T,T[n].parent);}}}

static void make_all_hash(uint32 n,uint64 Z)
{uint32 k=Z&ALL_HASH_MASK;
 while (ALL_HASH[k].key) {k++; if (k==(ALL_HASH_MASK+1)) k=0;}
 ALL_HASH[k].key=Z; ALL_HASH[k].node=n;}

PN_NODE* try_merge
(PN_NODE *T1,PN_NODE *T2,HASH* *BH,uint32* BHM,HASH* *AH,uint32* AHM)
{uint32 sz,u,all; typePOS POS[1]; PN_NODE *MT;
 POS->DYN_ROOT=CALLOC(MAX_PLY,sizeof(typeDYNAMIC)); POS->ZTAB=NULL;
 POS->DYN=POS->DYN_ROOT+1; init_position(POS,"startpos");
 forward_trans(T1); sz=T1[0].size; for (u=1;u<sz;u++) T1[u].size=0;
 repair_children(T1); fflush(stdout); repair_loops(T1); fflush(stdout);
 forward_trans(T2); sz=T2[0].size; for (u=1;u<sz;u++) T2[u].size=0;
 repair_children(T2); fflush(stdout); repair_loops(T2); fflush(stdout);
 sz=T1[0].size; for (u=1;u<sz;u++) T1[u].size=0;
 sz=T2[0].size; for (u=1;u<sz;u++) T2[u].size=0;
 sz=T1[0].size+T2[0].size+0x100000; MT=CALLOC(sz,sizeof(PN_NODE));
 all=2U<<BSR(sz+sz/4); BOOK_HASH=CALLOC(all,sizeof(HASH));
 BOOK_HASH_MASK=all-1; for (u=0;u<all;u++) BOOK_HASH[u].key=0;
 all=2U<<BSR(sz+sz/2); ALL_HASH=CALLOC(all,sizeof(HASH));
 ALL_HASH_MASK=all-1; for (u=0;u<all;u++) ALL_HASH[u].key=0;
 *BH=BOOK_HASH; *BHM=BOOK_HASH_MASK; *AH=ALL_HASH; *AHM=ALL_HASH_MASK;
 MT[0].child=MT[0].parent=MT[0].sibling=0; MT[0].good=MT[0].bad=0;
 MT[0].loop=MT[0].trans=0; MT[0].hash=0;
 MT[0].move=MT[0].flags=MT[0].killer=0;
 MT[0].size=2; MT[1].good=MT[1].bad=1; MT[1].hash=POS->DYN->HASH;
 MT[1].parent=MT[1].child=MT[1].sibling=0; MT[1].trans=1; MT[1].loop=0;
 MT[1].size=0; MT[1].move=0; MT[1].flags=16; MT[1].killer=0;
 merge_trees(POS,T1,1,T2,1,MT,1); free(POS->DYN_ROOT);
 for (u=1;u<MT[0].size;u++) make_all_hash(u,MT[u].hash);
 backtrack_info(MT); return MT;}
